000100 IDENTIFICATION DIVISION.                                          00010000
000200 PROGRAM-ID.             UT0650.                                   00020000
000300*AUTHOR.                 DAVE LENNARD.                             00030000
000400*DATE-WRITTEN.           OCTOBER 1974.                             00040000
000500*                                                                  00050000
000600*    VERSION UT06-B01 FOR COMP.LANG.COBOL TUE-21-OCT-2003.         00060000
000700*    AN ATTEMPT TO CONVERT TO IBM VS COBOL II SYNTAX.              00070000
000800*    ARNOLD.TREMBLEY@ATT.NET                                       00080000
000900                                                                   00090000
001000 ENVIRONMENT DIVISION.                                             00100000
001100                                                                   00110000
001200 CONFIGURATION SECTION.                                            00120000
001300                                                                   00130000
001400 SOURCE-COMPUTER.        IBM-PC.                                   00140000
001500 OBJECT-COMPUTER.        IBM-PC.                                   00150000
001600                                                                   00160000
001700 SPECIAL-NAMES.                                                    00170000
001800*    (SPECIAL-NAMES WILL BE HANDLED DIFFERENTLY - AJT)             00180000
001900*    (SEE PROGRAM-SWITCHES IN WORKING-STORAGE)                     00190000
002000*    DATE IS EXEC-DATE.                                            00200000
002100*    BIT-01 ON IS COMPILE-AGAIN.                                   00210000
002200*    BIT-02 ON IS PRINT-PROGRAM.                                   00220000
002300*    BIT-03 ON IS HALT-AFTER-COMPILE.                              00230000
002400                                                                   00240000
002500 INPUT-OUTPUT SECTION.                                             00250000
002600                                                                   00260000
002700 FILE-CONTROL.                                                     00270000
002800     SELECT  IN-DA           ASSIGN TO INDA.                       00280000
002900     SELECT  OUT-DA          ASSIGN TO OUTDA.                      00290000
003000     SELECT  IN-MT           ASSIGN TO INMT.                       00300000
003100     SELECT  OUT-MT-2048     ASSIGN TO OUTMT1.                     00310000
003200     SELECT  OUT-MT-512      ASSIGN TO OUTMT2.                     00320000
003300     SELECT  OUT-MT-128      ASSIGN TO OUTMT3.                     00330000
003400     SELECT  OUT-MT-64       ASSIGN TO OUTMT4.                     00340000
003500     SELECT  CARD-FILE       ASSIGN CARDFILE.                      00350000
003600                                                                   00360000
003700 I-O-CONTROL.                                                      00370000
003800*    SAME RECORD AREA FOR IN-DA OUT-DA IN-MT                       00380000
003900*        OUT-MT-2048 OUT-MT-512 OUT-MT-128 OUT-MT-64.              00390000
004000*    SAME AREA FOR IN-DA IN-MT.                                    00400000
004100*    SAME AREA FOR OUT-DA                                          00410000
004200*        OUT-MT-2048 OUT-MT-512 OUT-MT-128 OUT-MT-64.              00420000
004300*    APPLY REPLY-WORD TO TRANSFER-REPLY ON IN-DA.                  00430000
004400*    APPLY REPLY-WORD TO TRANSFER-REPLY ON OUT-DA.                 00440000
004500                                                                   00450000
004600 DATA DIVISION.                                                    00460000
004700                                                                   00470000
004800 FILE SECTION.                                                     00480000
004900                                                                   00490000
005000 FD IN-MT                                                          00500000
005100     LABEL RECORDS ARE STANDARD                                    00510000
005200     RECORD CONTAINS 2400 CHARACTERS                               00520000
005300     BLOCK CONTAINS  0    RECORDS.                                 00530000
005400                                                                   00540000
005500* NOTE THE SIZES OF THESE AREAS ARE ALSO DEFINED IN TABLE-SIZES    00550000
005600 01  IN-RECORD.                                                    00560000
005700     03  RECORD-AREA.                                              00570000
005800         05  CHAR                OCCURS 800  PIC X.                00580000
005900     03  WORK-AREA.                                                00590000
006000         05  FILLER              OCCURS 400  PIC X.                00600000
006100     03  LITERAL-AREA.                                             00610000
006200         05  FILLER              OCCURS 400  PIC X.                00620000
006300     03  SCRATCH-PAD.                                              00630000
006400         05  SCR-WORD            PIC S9(6)   COMP SYNC.            00640000
006500         05  FILLER              PIC X(36).                        00650000
006600     03  CARD-AREA               PIC X(80).                        00660000
006700     03  A510-AREA.                                                00670000
006800         05  A510-LINES-PAGE     PIC S9(6)   COMP SYNC.            00680000
006900         05  A510-TOT-LINES      PIC S9(6)   COMP SYNC.            00690000
007000         05  A510-LINES-THIS     PIC S9(6)   COMP SYNC.            00700000
007100         05  A510-PAGE           PIC S9(6)   COMP SYNC.            00710000
007200         05  A510-HEADS          PIC S9(6)   COMP SYNC.            00720000
007300         05  A510-REPLY          PIC S9(6)   COMP SYNC.            00730000
007400         05  A510-CONTROL        PIC X(4).                         00740000
007500     03  PRINT-AREA.                                               00750000
007600         05  FILLER              OCCURS 160  PIC X.                00760000
007700     03  A510-HD1-CONTROL        PIC X(4).                         00770000
007800     03  HEAD-1.                                                   00780000
007900         05  FILLER              PIC X(50).                        00790000
008000         05  HEAD-1-COM          PIC X(60).                        00800000
008100         05  FILLER              PIC X(50).                        00810000
008200     03  A510-HD2-CONTROL        PIC X(4).                         00820000
008300     03  HEAD-2.                                                   00830000
008400         05  FILLER              OCCURS 160  PIC X.                00840000
008500     03  A510-HD3-CONTROL        PIC X(4).                         00850000
008600     03  HEAD-3.                                                   00860000
008700         05  FILLER              OCCURS 160  PIC X.                00870000
008800                                                                   00880000
008900 01  FILLER.                                                       00890000
009000     03  RECORD-WORD-COUNT       PIC S9(6)   COMP SYNC.            00900000
009100                                                                   00910000
009200 01  FILLER.                                                       00920000
009300     03  BINARY-WORD             OCCURS 400                        00930000
009400                                 PIC S9(6)   COMP SYNC.            00940000
009500                                                                   00950000
009600 01  M5DA-RECORD.                                                  00960000
009700     03  FILLER                  OCCURS 15   PIC X(4).             00970000
009800     03  M5DA-INDEX-BITS         PIC X(4).                         00980000
009900                                                                   00990000
010000 FD  IN-DA                                                         01000000
010100     LABEL RECORDS ARE STANDARD                                    01010000
010200     RECORD CONTAINS 2048 CHARACTERS                               01020000
010300     BLOCK CONTAINS  0    RECORDS.                                 01030000
010400                                                                   01040000
010500 01  FILLER.                                                       01050000
010600     03  FILLER                  OCCURS 800  PIC X.                01060000
010700                                                                   01070000
010800 FD  OUT-DA                                                        01080000
010900     LABEL RECORDS ARE STANDARD                                    01090000
011000     RECORD CONTAINS 2048 CHARACTERS                               01100000
011100     BLOCK CONTAINS  0    RECORDS.                                 01110000
011200                                                                   01120000
011300 01  OUT-DA-REC.                                                   01130000
011400     03  FILLER                  OCCURS 800  PIC X.                01140000
011500                                                                   01150000
011600 FD  OUT-MT-2048                                                   01160000
011700     LABEL RECORDS ARE STANDARD                                    01170000
011800     RECORD CONTAINS 2048 CHARACTERS                               01180000
011900     BLOCK CONTAINS  0    RECORDS.                                 01190000
012000                                                                   01200000
012100 01  OUT-MT-2048-REC.                                              01210000
012200     03  FILLER                  OCCURS 800  PIC X.                01220000
012300                                                                   01230000
012400 FD  OUT-MT-512                                                    01240000
012500     LABEL RECORDS ARE STANDARD                                    01250000
012600     RECORD CONTAINS 512 CHARACTERS                                01260000
012700     BLOCK CONTAINS  0    RECORDS.                                 01270000
012800                                                                   01280000
012900 01  OUT-MT-512-REC.                                               01290000
013000     03  FILLER                  OCCURS 512  PIC X.                01300000
013100                                                                   01310000
013200 FD  OUT-MT-128                                                    01320000
013300     LABEL RECORDS ARE STANDARD                                    01330000
013400     RECORD CONTAINS 128 CHARACTERS                                01340000
013500     BLOCK CONTAINS  0    RECORDS.                                 01350000
013600                                                                   01360000
013700 01  OUT-MT-128-REC.                                               01370000
013800     03  FILLER                  OCCURS 128  PIC X.                01380000
013900                                                                   01390000
014000 FD  OUT-MT-64                                                     01400000
014100     LABEL RECORDS ARE STANDARD                                    01410000
014200     RECORD CONTAINS 64 CHARACTERS                                 01420000
014300     BLOCK CONTAINS  0    RECORDS.                                 01430000
014400                                                                   01440000
014500 01  OUT-MT-64-REC.                                                01450000
014600     03  FILLER                  OCCURS 64   PIC X.                01460000
014700                                                                   01470000
014800 FD  CARD-FILE.                                                    01480000
014900                                                                   01490000
015000 01  CARD-RECORD.                                                  01500000
015100     03  CARD-CHAR               OCCURS 80   PIC X.                01510000
015200                                                                   01520000
015300 WORKING-STORAGE SECTION.                                          01530000
015400                                                                   01540000
015500 01  PROGRAM-SWITCHES.                                             01550000
015600     05  SW-BIT-01               PIC X(01)   VALUE "F".            01560000
015700         88  COMPILE-AGAIN                   VALUE "T".            01570000
015800     05  SW-BIT-02               PIC X(01)   VALUE "F".            01580000
015900         88  PRINT-PROGRAM                   VALUE "T".            01590000
016000     05  SW-BIT-03               PIC X(01)   VALUE "F".            01600000
016100         88  HALT-AFTER-COMPILE              VALUE "T".            01610000
016200                                                                   01620000
016300 01  PRINT-LINE.                                                   01630000
016400     03  FILLER                  PIC X(8)    VALUE SPACES.         01640000
016500     03  LIST-CARD.                                                01650000
016600         05  LIST-CHAR           OCCURS 80   PIC X   VALUE SPACE.  01660000
016700     03  FILLER                  PIC X(4)    VALUE SPACES.         01670000
016800     03  LIST-COMMENT            PIC X(20)   VALUE SPACES.         01680000
016900     03  LIST-NAME               PIC X(16)   VALUE SPACES.         01690000
017000     03  LIST-DATE               PIC X(80)   VALUE SPACES.         01700000
017100     03  FILLER                  PIC X(24)   VALUE SPACES.         01710000
017200                                                                   01720000
017300 01  FILLER                  REDEFINES PRINT-LINE.                 01730000
017400     03  FILLER                  PIC X(8).                         01740000
017500     03  LIST-CELL               PIC Z(6).                         01750000
017600     03  FILLER                  PIC XXXX.                         01760000
017700     03  LIST-LABEL.                                               01770000
017800         05  FILLER              PIC XXXX.                         01780000
017900         05  LIST-TYPE           PIC X(12).                        01790000
018000     03  LIST-LOC1               PIC Z(6).                         01800000
018100     03  LIST-LOC2               PIC Z(6).                         01810000
018200     03  LIST-NUM                PIC Z(6).                         01820000
018300     03  LIST-EXIT               PIC Z(6).                         01830000
018400                                                                   01840000
018500 01  HOUSEKEEPING.                                                 01850000
018600     03  REPLY-WORD              PIC S9(6)   COMP SYNC VALUE +0.   01860000
018700                                                                   01870000
018800 01  WORK-FIELDS.                                                  01880000
018900*AJT 03  WORK-2-BITS             PIC 11      SYNC.                 01890000
019000     03  WORK-2-BITS             PIC S9(6)   COMP SYNC VALUE +0.   01900000
019100     03  WORK-CHAR               PIC X       VALUE SPACE.          01910000
019200     03  NUM-FIELD-X.                                              01920000
019300         05  NUM-CHAR            OCCURS 6    PIC X   VALUE SPACE.  01930000
019400     03  NUM-FIELD           REDEFINES NUM-FIELD-X   PIC 9(6).     01940000
019500                                                                   01950000
019600 01  WORD-AREA.                                                    01960000
019700     03  WORD-CHAR               OCCURS 80   PIC X   VALUE SPACE.  01970000
019800                                                                   01980000
019900 01  FILLER                  REDEFINES WORD-AREA.                  01990000
020000     03  WORD-16-CHAR.                                             02000000
020100         05  WORD-2-CHAR         PIC XX.                           02010000
020200         05  FILLER              PIC X(14).                        02020000
020300     03  FILLER                  PIC X(64).                        02030000
020400                                                                   02040000
020500 01  FLAGS                   USAGE IS COMP.                        02050000
020600     03  END-WORDS-FLAG          PIC S9(6)   SYNC VALUE ZERO.      02060000
020700     03  END-CARDS-FLAG          PIC S9(6)   SYNC VALUE ZERO.      02070000
020800     03  END-FILE-FLAG           PIC S9(6)   SYNC VALUE ZERO.      02080000
020900     03  OUT-MT-FLAG             PIC S9(6)   SYNC VALUE ZERO.      02090000
021000     03  END-CHAR-FLAG           PIC S9(6)   SYNC VALUE ZERO.      02100000
021100     03  ERROR-FLAG              PIC S9(6)   SYNC VALUE ZERO.      02110000
021200     03  QUOTE-FLAG              PIC S9(6)   SYNC VALUE ZERO.      02120000
021300     03  LABEL-FLAG              PIC S9(6)   SYNC VALUE ZERO.      02130000
021400     03  COMPILE-FLAG            PIC S9(6)   SYNC VALUE ZERO.      02140000
021500     03  FULL-STOP-FLAG          PIC S9(6)   SYNC VALUE ZERO.      02150000
021600     03  LOC-FLAG                PIC S9(6)   SYNC VALUE ZERO.      02160000
021700     03  AND-FLAG                PIC S9(6)   SYNC VALUE ZERO.      02170000
021800     03  OR-FLAG                 PIC S9(6)   SYNC VALUE ZERO.      02180000
021900     03  NOT-FLAG                PIC S9(6)   SYNC VALUE ZERO.      02190000
022000     03  LOC-QUOTE-FLAG          PIC S9(6)   SYNC VALUE ZERO.      02200000
022100     03  CHAR-AREA-FLAG          PIC S9(6)   SYNC VALUE ZERO.      02210000
022200                                                                   02220000
022300 01  POINTERS                USAGE IS COMP.                        02230000
022400     03  CELL-POINT              PIC S9(6)   SYNC VALUE ZERO.      02240000
022500     03  WORD-CHAR-POINT         PIC S9(6)   SYNC VALUE ZERO.      02250000
022600     03  DATA-CHAR-POINT         PIC S9(6)   SYNC VALUE ZERO.      02260000
022700     03  LITERAL-CHAR-POINT      PIC S9(6)   SYNC VALUE ZERO.      02270000
022800     03  FIRST-CHAR-POINT        PIC S9(6)   SYNC VALUE ZERO.      02280000
022900     03  CARD-CHAR-POINT         PIC S9(6)   SYNC VALUE ZERO.      02290000
023000     03  NEED-EXIT-POINT         PIC S9(6)   SYNC VALUE ZERO.      02300000
023100     03  NUM-POINT               PIC S9(6)   SYNC VALUE ZERO.      02310000
023200     03  LOC-POINT               PIC S9(6)   SYNC VALUE ZERO.      02320000
023300     03  AUG-POINT               PIC S9(6)   SYNC VALUE ZERO.      02330000
023400     03  POYNT                   PIC S9(6)   SYNC VALUE ZERO.      02340000
023500     03  FILE-POINT              PIC S9(6)   SYNC VALUE ZERO.      02350000
023600     03  IN-FILE-POINT           PIC S9(6)   SYNC VALUE ZERO.      02360000
023700     03  OUT-FILE-POINT          PIC S9(6)   SYNC VALUE ZERO.      02370000
023800                                                                   02380000
023900 01  TOTALS                  USAGE IS COMP.                        02390000
024000     03  RECS-IN                 PIC S9(6)   SYNC VALUE ZERO.      02400000
024100     03  RECS-OUT                PIC S9(6)   SYNC VALUE ZERO.      02410000
024200                                                                   02420000
024300 01  COMPILE-TOTALS          USAGE IS COMP.                        02430000
024400     03  TOTAL-CELLS             PIC S9(6)   SYNC VALUE ZERO.      02440000
024500                                                                   02450000
024600 01  NUMERIC-WORK-AREAS.                                           02460000
024700     03  LOC-LENGTH              PIC S9(6)   COMP SYNC VALUE +0.   02470000
024800     03  NUMBER-X4.                                                02480000
024900         05  NUMBER-N6           PIC S9(6)   COMP SYNC VALUE +0.   02490000
025000                                                                   02500000
025100 01  TABLE-SIZES             USAGE IS COMP.                        02510000
025200     03  RECORD-CHARS            PIC S9(6)   SYNC VALUE +800.      02520000
025300     03  WORK-CHARS              PIC S9(6)   SYNC VALUE +400.      02530000
025400     03  LITERAL-CHARS           PIC S9(6)   SYNC VALUE +400.      02540000
025500     03  NO-OF-CELLS             PIC S9(6)   SYNC VALUE +200.      02550000
025600                                                                   02560000
025700 01  AREA-START-LOCATIONS    USAGE IS COMP.                        02570000
025800     03  WORK-AREA-START         PIC S9(6)   SYNC VALUE +800.      02580000
025900     03  LITERAL-AREA-START      PIC S9(6)   SYNC VALUE +1200.     02590000
026000     03  LITERAL-AREA-END        PIC S9(6)   SYNC VALUE +1600.     02600000
026100     03  CARD-AREA-START         PIC S9(6)   SYNC VALUE +1640.     02610000
026200     03  A510-AREA-START         PIC S9(6)   SYNC VALUE +1720.     02620000
026300     03  PRINT-AREA-START        PIC S9(6)   SYNC VALUE +1748.     02630000
026400     03  H-HEAD-AREA-START       PIC S9(6)   SYNC VALUE +1912.     02640000
026500     03  I-HEAD-AREA-START       PIC S9(6)   SYNC VALUE +2076.     02650000
026600     03  J-HEAD-AREA-START       PIC S9(6)   SYNC VALUE +2240.     02660000
026700                                                                   02670000
026800 01  ONE-WORD-MOVE           USAGE IS COMP.                        02680000
026900     03  ONE-LOC                 PIC S9(6)   SYNC VALUE ZERO.      02690000
027000     03  ONE-SCR-LOC             PIC S9(6)   SYNC VALUE +1601.     02700000
027100     03  ONE-LENGTH              PIC S9(6)   SYNC VALUE +4.        02710000
027200                                                                   02720000
027300 01  INSTRUCTION-POINTERS.                                         02730000
027400     03  FILLER                  PIC S9(6)   COMP SYNC VALUE +1.   02740000
027500     03  FILLER                  PIC S9(6)   COMP SYNC VALUE +2.   02750000
027600     03  FILLER                  PIC S9(6)   COMP SYNC VALUE +3.   02760000
027700     03  FILLER                  PIC S9(6)   COMP SYNC VALUE +4.   02770000
027800     03  FILLER                  PIC S9(6)   COMP SYNC VALUE +5.   02780000
027900     03  FILLER                  PIC S9(6)   COMP SYNC VALUE +6.   02790000
028000     03  FILLER                  PIC S9(6)   COMP SYNC VALUE +7.   02800000
028100     03  FILLER                  PIC S9(6)   COMP SYNC VALUE +8.   02810000
028200     03  FILLER                  PIC S9(6)   COMP SYNC VALUE +9.   02820000
028300     03  FILLER                  PIC S9(6)   COMP SYNC VALUE +10.  02830000
028400     03  FILLER                  PIC S9(6)   COMP SYNC VALUE +11.  02840000
028500     03  FILLER                  PIC S9(6)   COMP SYNC VALUE +12.  02850000
028600     03  FILLER                  PIC S9(6)   COMP SYNC VALUE +13.  02860000
028700     03  FILLER                  PIC S9(6)   COMP SYNC VALUE +14.  02870000
028800     03  FILLER                  PIC S9(6)   COMP SYNC VALUE +15.  02880000
028900     03  FILLER                  PIC S9(6)   COMP SYNC VALUE +16.  02890000
029000     03  FILLER                  PIC S9(6)   COMP SYNC VALUE +17.  02900000
029100     03  FILLER                  PIC S9(6)   COMP SYNC VALUE +18.  02910000
029200     03  FILLER                  PIC S9(6)   COMP SYNC VALUE +19.  02920000
029300     03  FILLER                  PIC S9(6)   COMP SYNC VALUE +20.  02930000
029400     03  FILLER                  PIC S9(6)   COMP SYNC VALUE +21.  02940000
029500     03  FILLER                  PIC S9(6)   COMP SYNC VALUE +22.  02950000
029600     03  FILLER                  PIC S9(6)   COMP SYNC VALUE +23.  02960000
029700                                                                   02970000
029800* NOTE: KEEP INSTRUCTIONS IN THE SAME ORDER EVERYWHERE             02980000
029900 01  FILLER                  REDEFINES INSTRUCTION-POINTERS.       02990000
030000     03  TYPE-ADD                PIC S9(6)   COMP SYNC.            03000000
030100     03  TYPE-AUGMENT            PIC S9(6)   COMP SYNC.            03010000
030200     03  TYPE-CALL               PIC S9(6)   COMP SYNC.            03020000
030300     03  TYPE-DIVIDE             PIC S9(6)   COMP SYNC.            03030000
030400     03  TYPE-EXIT               PIC S9(6)   COMP SYNC.            03040000
030500     03  TYPE-GO                 PIC S9(6)   COMP SYNC.            03050000
030600     03  TYPE-IF-EQUAL-CHARS     PIC S9(6)   COMP SYNC.            03060000
030700     03  TYPE-IF-NOT-EQUAL-CHARS PIC S9(6)   COMP SYNC.            03070000
030800     03  TYPE-IF-GREAT-CHARS     PIC S9(6)   COMP SYNC.            03080000
030900     03  TYPE-IF-NOT-GREAT-CHARS PIC S9(6)   COMP SYNC.            03090000
031000     03  TYPE-IF-LESS-CHARS      PIC S9(6)   COMP SYNC.            03100000
031100     03  TYPE-IF-NOT-LESS-CHARS  PIC S9(6)   COMP SYNC.            03110000
031200     03  TYPE-LABEL              PIC S9(6)   COMP SYNC.            03120000
031300     03  TYPE-MOVE-1B-D          PIC S9(6)   COMP SYNC.            03130000
031400     03  TYPE-MOVE-CHARS         PIC S9(6)   COMP SYNC.            03140000
031500     03  TYPE-MOVE-D-1B          PIC S9(6)   COMP SYNC.            03150000
031600     03  TYPE-MULTIPLY           PIC S9(6)   COMP SYNC.            03160000
031700     03  TYPE-PERFORM            PIC S9(6)   COMP SYNC.            03170000
031800     03  TYPE-PRINT              PIC S9(6)   COMP SYNC.            03180000
031900     03  TYPE-READ               PIC S9(6)   COMP SYNC.            03190000
032000     03  TYPE-STOP               PIC S9(6)   COMP SYNC.            03200000
032100     03  TYPE-SUBTRACT           PIC S9(6)   COMP SYNC.            03210000
032200     03  TYPE-WRITE              PIC S9(6)   COMP SYNC.            03220000
032300                                                                   03230000
032400 01  INSTRUCTION-NAMES.                                            03240000
032500     03  FILLER                  PIC X(8)    VALUE "ADD".          03250000
032600     03  FILLER                  PIC X(8)    VALUE "AUGMENT".      03260000
032700     03  FILLER                  PIC X(8)    VALUE "CALL".         03270000
032800     03  FILLER                  PIC X(8)    VALUE "DIVIDE".       03280000
032900     03  FILLER                  PIC X(8)    VALUE "EXIT".         03290000
033000     03  FILLER                  PIC X(8)    VALUE "GO TO".        03300000
033100     03  FILLER                  PIC X(8)    VALUE "IF =".         03310000
033200     03  FILLER                  PIC X(8)    VALUE "IF NOT =".     03320000
033300     03  FILLER                  PIC X(8)    VALUE "IF >".         03330000
033400     03  FILLER                  PIC X(8)    VALUE "IF NOT >".     03340000
033500     03  FILLER                  PIC X(8)    VALUE "IF <".         03350000
033600     03  FILLER                  PIC X(8)    VALUE "IF NOT <".     03360000
033700     03  FILLER                  PIC X(8)    VALUE "LABEL".        03370000
033800     03  FILLER                  PIC X(8)    VALUE "MOVE B-D".     03380000
033900     03  FILLER                  PIC X(8)    VALUE "MOVE TO".      03390000
034000     03  FILLER                  PIC X(8)    VALUE "MOVE D-B".     03400000
034100     03  FILLER                  PIC X(8)    VALUE "MULTIPLY".     03410000
034200     03  FILLER                  PIC X(8)    VALUE "PERFORM".      03420000
034300     03  FILLER                  PIC X(8)    VALUE "PRINT".        03430000
034400     03  FILLER                  PIC X(8)    VALUE "READ".         03440000
034500     03  FILLER                  PIC X(8)    VALUE "STOP".         03450000
034600     03  FILLER                  PIC X(8)    VALUE "SUBTRACT".     03460000
034700     03  FILLER                  PIC X(8)    VALUE "WRITE".        03470000
034800                                                                   03480000
034900 01  FILLER                  REDEFINES INSTRUCTION-NAMES.          03490000
035000     03  INSTRUCTION-NAME        OCCURS 23   PIC X(8).             03500000
035100                                                                   03510000
035200* NOTE: ANY DESIRED SUBROUTINES CAN BE INCLUDED HERE               03520000
035300* ALSO INCLUDE CODE TO TEST FOR AND RUN THE SUBROUTINE             03530000
035400 01  SUBROUTINE-TYPES        USAGE IS COMP.                        03540000
035500     03  SUBR-M5DAEXPAND         PIC S9(6)   SYNC VALUE +1.        03550000
035600                                                                   03560000
035700 01  CARD-PRINTER-STATUS.                                          03570000
035800     03  CARD-PRINTER-FLAG       PIC S9(6)   COMP SYNC VALUE +0.   03580000
035900                                                                   03590000
036000 01  FILE-OPEN-MODES         USAGE IS COMP.                        03600000
036100     03  OPEN-INPUT              PIC S9(6)   SYNC VALUE +1.        03610000
036200     03  OPEN-OUTPUT             PIC S9(6)   SYNC VALUE +2.        03620000
036300                                                                   03630000
036400 01  FILE-TYPES              USAGE IS COMP.                        03640000
036500     03  INPUT-DA                PIC S9(6)   SYNC VALUE +1.        03650000
036600     03  OUTPUT-DA               PIC S9(6)   SYNC VALUE +2.        03660000
036700     03  FILE-TYPE-DA            PIC S9(6)   SYNC VALUE +3.        03670000
036800     03  INPUT-MT                PIC S9(6)   SYNC VALUE +4.        03680000
036900     03  OUTPUT-MT-2048          PIC S9(6)   SYNC VALUE +5.        03690000
037000     03  OUTPUT-MT-1024          PIC S9(6)   SYNC VALUE +6.        03700000
037100     03  OUTPUT-MT-512           PIC S9(6)   SYNC VALUE +7.        03710000
037200     03  OUTPUT-MT-128           PIC S9(6)   SYNC VALUE +8.        03720000
037300     03  OUTPUT-MT-64            PIC S9(6)   SYNC VALUE +9.        03730000
037400                                                                   03740000
037500 01  FILE-TABLE-SIZE             PIC S9(6)   COMP SYNC VALUE +15.  03750000
037600                                                                   03760000
037700 01  FILE-DATA-TABLE.                                              03770000
037800     03  FILE-DATA           OCCURS 15.                            03780000
037900         05  FTAB-NAME           PIC X(12).                        03790000
038000         05  FTAB-GEN            PIC S9(6)   COMP SYNC.            03800000
038100         05  FTAB-BLOCK          PIC S9(6)   COMP SYNC.            03810000
038200         05  FTAB-FILE-NO        PIC S9(6)   COMP SYNC.            03820000
038300         05  FTAB-TYPE           PIC S9(6)   COMP SYNC.            03830000
038400         05  FTAB-MODE           PIC S9(6)   COMP SYNC.            03840000
038500                                                                   03850000
038600 01  FILE-STATUS-TABLE.                                            03860000
038700     03  FILE-STATUS-FLAG        OCCURS 15 TIMES                   03870000
038800                                 PIC S9(6)   COMP SYNC.            03880000
038900                                                                   03890000
039000 01  WORK-FILE-DATA.                                               03900000
039100     03  WORK-NAME               PIC X(12).                        03910000
039200     03  WORK-GEN                PIC S9(6)   COMP SYNC.            03920000
039300     03  WORK-BLOCK              PIC S9(6)   COMP SYNC.            03930000
039400     03  WORK-FILE-NO            PIC S9(6)   COMP SYNC.            03940000
039500     03  WORK-TYPE               PIC S9(6)   COMP SYNC.            03950000
039600     03  WORK-MODE               PIC S9(6)   COMP SYNC.            03960000
039700                                                                   03970000
039800 01  FILE-WORKING.                                                 03980000
039900     03  WORK-MEDIUM             PIC XX.                           03990000
040000     03  FILLER                  PIC XX.                           04000000
040100     03  MODE-REQUIRED           PIC S9(6)   COMP SYNC.            04010000
040200                                                                   04020000
040300 01  IN-FILE-DATA.                                                 04030000
040400     03  IN-NAME                 PIC X(12).                        04040000
040500     03  IN-GEN                  PIC S9(6)   COMP SYNC.            04050000
040600     03  IN-BLOCK                PIC S9(6)   COMP SYNC.            04060000
040700     03  IN-FILE-NO              PIC S9(6)   COMP SYNC.            04070000
040800     03  IN-TYPE                 PIC S9(6)   COMP SYNC.            04080000
040900     03  IN-MODE                 PIC S9(6)   COMP SYNC.            04090000
041000                                                                   04100000
041100 01  OUT-FILE-DATA.                                                04110000
041200     03  OUT-NAME                PIC X(12).                        04120000
041300     03  OUT-GEN                 PIC S9(6)   COMP SYNC.            04130000
041400     03  OUT-BLOCK               PIC S9(6)   COMP SYNC.            04140000
041500     03  OUT-FILE-NO             PIC S9(6)   COMP SYNC.            04150000
041600     03  OUT-TYPE                PIC S9(6)   COMP SYNC.            04160000
041700     03  OUT-MODE                PIC S9(6)   COMP SYNC.            04170000
041800                                                                   04180000
041900* NOTE: AN INSTRUCTION AND PARAMETERS ARE STORED HERE WHILE BEING  04190000
042000* GENERATED OR EXECUTED                                            04200000
042100 01  CELL.                                                         04210000
042200     03  CELL-TYPE               PIC S9(6)   COMP SYNC.            04220000
042300     03  CELL-LABEL.                                               04230000
042400         05  CELL-LOC1           PIC S9(6)   COMP SYNC.            04240000
042500         05  CELL-LOC2           PIC S9(6)   COMP SYNC.            04250000
042600         05  CELL-NUM            PIC S9(6)   COMP SYNC.            04260000
042700         05  CELL-EXIT           PIC S9(6)   COMP SYNC.            04270000
042800     03  FILLER REDEFINES CELL-LABEL.                              04280000
042900         05  CELL-WORD       OCCURS 4 TIMES                        04290000
043000                                 PIC S9(6)   COMP SYNC.            04300000
043100                                                                   04310000
043200 01  AUG-STORE.                                                    04320000
043300     03  AUG-WORD            OCCURS 4 TIMES                        04330000
043400                                 PIC S9(6)   COMP SYNC.            04340000
043500                                                                   04350000
043600 01  CELL-TABLE.                                                   04360000
043700     03  CELL-STORE          OCCURS 200 TIMES.                     04370000
043800         05  CELL-STORE-TYPE     PIC S9(6)   COMP SYNC.            04380000
043900         05  CELL-STORE-LABEL.                                     04390000
044000             07  CELL-STORE-LOC1 PIC S9(6)   COMP SYNC.            04400000
044100             07  CELL-STORE-LOC2 PIC S9(6)   COMP SYNC.            04410000
044200             07  CELL-STORE-NUM  PIC S9(6)   COMP SYNC.            04420000
044300             07  CELL-STORE-EXIT PIC S9(6)   COMP SYNC.            04430000
044400     03  FILLER                  PIC X(4)    VALUE ZEROS.          04440000
044500                                                                   04450000
044600 PROCEDURE DIVISION.                                               04460000
044700                                                                   04470000
044800 COMPILE SECTION.                                                  04480000
044900                                                                   04490000
045000 TEST-IF-COMPILED.                                                 04500000
045100     PERFORM OPEN-CARD-PRINTER.                                    04510000
045200     IF PRINT-PROGRAM                                              04520000
045300         MOVE 100 TO A510-LINES-THIS                               04530000
045400         GO TO PRINT-CELLS.                                        04540000
045500     IF COMPILE-AGAIN                                              04550000
045600         GO TO PRINT-HEADINGS.                                     04560000
045700     IF COMPILE-FLAG = 1                                           04570000
045800         GO TO RUN-GENERATED-PROGRAM.                              04580000
045900                                                                   04590000
046000 PRINT-HEADINGS.                                                   04600000
046100     MOVE "#UT06/4A  PROGRAM GENERATOR"                            04610000
046200             TO PRINT-LINE.                                        04620000
046300*AJT ACCEPT LIST-DATE FROM EXEC-DATE.                              04630000
046400      ACCEPT LIST-DATE FROM DATE.                                  04640000
046500     MOVE ZERO TO FLAGS POINTERS IN-RECORD                         04650000
046600          FILE-DATA-TABLE FILE-STATUS-TABLE                        04660000
046700          CELL-TABLE CELL.                                         04670000
046800     MOVE SPACES TO LITERAL-AREA.                                  04680000
046900     MOVE 100 TO CARD-CHAR-POINT.                                  04690000
047000     ADD 1 LITERAL-AREA-START GIVING LITERAL-CHAR-POINT.           04700000
047100     MOVE PRINT-LINE             TO HEAD-1.                        04710000
047200     MOVE SPACES                 TO HEAD-2.                        04720000
047300     MOVE SPACES                 TO HEAD-3.                        04730000
047400     MOVE SPACES TO PRINT-LINE.                                    04740000
047500     MOVE 56 TO A510-LINES-PAGE.                                   04750000
047600     MOVE 100 TO A510-LINES-THIS.                                  04760000
047700     MOVE 3 TO A510-HEADS.                                         04770000
047800     MOVE "HEAD" TO A510-HD1-CONTROL.                              04780000
047900     MOVE "SP 2" TO A510-HD2-CONTROL.                              04790000
048000     MOVE "SP 1" TO A510-HD3-CONTROL.                              04800000
048100     MOVE "SP 1" TO A510-CONTROL.                                  04810000
048200     MOVE "LISTING OF SOURCE CARDS:" TO LIST-CARD.                 04820000
048300     PERFORM PRINT 2 TIMES.                                        04830000
048400     MOVE 1 TO CELL-POINT.                                         04840000
048500                                                                   04850000
048600 NEXT-WORD.                                                        04860000
048700     PERFORM READAWORD.                                            04870000
048800                                                                   04880000
048900 CHECK-WORD.                                                       04890000
049000     MOVE ZERO TO CELL.                                            04900000
049100     IF END-WORDS-FLAG = 1                                         04910000
049200         PERFORM CREATE-RETURN-CELL                                04920000
049300         SUBTRACT 1 FROM CELL-POINT GIVING TOTAL-CELLS             04930000
049400         GO TO CHECK-LABELS.                                       04940000
049500     IF QUOTE-FLAG = 1                                             04950000
049600         PERFORM PRINT-ERROR                                       04960000
049700         GO TO NEXT-WORD.                                          04970000
049800     IF WORD-2-CHAR = "AD"   GO TO COMPILE-ADD.                    04980000
049900     IF WORD-2-CHAR = "AU"   GO TO COMPILE-AUGMENT.                04990000
050000     IF WORD-2-CHAR = "CA"   GO TO COMPILE-CALL.                   05000000
050100     IF WORD-2-CHAR = "DI"   GO TO COMPILE-DIVIDE.                 05010000
050200     IF WORD-2-CHAR = "EL"   GO TO COMPILE-ELSE.                   05020000
050300     IF WORD-2-CHAR = "GO"   GO TO COMPILE-GO.                     05030000
050400     IF WORD-2-CHAR = "IF"   GO TO COMPILE-IF.                     05040000
050500     IF WORD-2-CHAR = "IN"   GO TO COMPILE-IN.                     05050000
050600     IF WORD-2-CHAR = "MO"   GO TO COMPILE-MOVE.                   05060000
050700     IF WORD-2-CHAR = "MU"   GO TO COMPILE-MULTIPLY.               05070000
050800     IF WORD-2-CHAR = "OU"   GO TO COMPILE-OUT.                    05080000
050900     IF WORD-2-CHAR = "PE"   GO TO COMPILE-PERFORM.                05090000
051000     IF WORD-2-CHAR = "PR"   GO TO COMPILE-PRINT.                  05100000
051100     IF WORD-2-CHAR = "RE"   GO TO COMPILE-READ.                   05110000
051200     IF WORD-2-CHAR = "ST"   GO TO COMPILE-STOP.                   05120000
051300     IF WORD-2-CHAR = "SU"   GO TO COMPILE-SUBTRACT.               05130000
051400     IF WORD-2-CHAR = "WR"   GO TO COMPILE-WRITE.                  05140000
051500     IF WORD-2-CHAR = "**"                                         05150000
051600         MOVE 1 TO END-WORDS-FLAG                                  05160000
051700         GO TO CHECK-WORD.                                         05170000
051800                                                                   05180000
051900 COMPILE-LABEL.                                                    05190000
052000     IF WORD-CHAR (1) NOT NUMERIC                                  05200000
052100          GO TO PRINT-ERROR.                                       05210000
052200     PERFORM CREATE-RETURN-CELL.                                   05220000
052300     MOVE 1 TO LABEL-FLAG.                                         05230000
052400     MOVE TYPE-LABEL TO CELL-TYPE.                                 05240000
052500     MOVE WORD-16-CHAR TO CELL-LABEL.                              05250000
052600     PERFORM STORE-CELL.                                           05260000
052700     GO TO NEXT-WORD.                                              05270000
052800                                                                   05280000
052900 COMPILE-ADD.                                                      05290000
053000     MOVE TYPE-ADD TO CELL-TYPE.                                   05300000
053100     GO TO COMPILE-ARITHMETIC.                                     05310000
053200                                                                   05320000
053300 COMPILE-ARITHMETIC.                                               05330000
053400     PERFORM READAWORD.                                            05340000
053500     PERFORM CONVERT-LOCATION.                                     05350000
053600     PERFORM LOC-TO-BINARY THRU LTB-EXIT.                          05360000
053700     MOVE LOC-POINT TO CELL-LOC1.                                  05370000
053800     MOVE LOC-LENGTH TO CELL-NUM.                                  05380000
053900     PERFORM READAWORD.                                            05390000
054000     IF WORD-2-CHAR = "TO" OR "FR" OR "BY" OR "IN"                 05400000
054100         PERFORM READAWORD.                                        05410000
054200     PERFORM CONVERT-LOCATION.                                     05420000
054300     PERFORM LOC-TO-BINARY THRU LTB-EXIT.                          05430000
054400     MOVE LOC-POINT TO CELL-LOC2.                                  05440000
054500     MOVE LOC-LENGTH TO CELL-EXIT.                                 05450000
054600     IF CELL-NUM = -4 AND CELL-EXIT = -4                           05460000
054700         PERFORM STORE-CELL                                        05470000
054800         GO TO NEXT-WORD.                                          05480000
054900                                                                   05490000
055000* IT LOOKS AS IF ARITHMETIC ONLY ON 1 WORD FIELDS IS ALLOWABLE     05500000
055100* WITH UT06/4A. I HAVE LOTS OF PENCILLED AMENDMENTS THAT ALLOW     05510000
055200* OTHER SIZE FIELDS                                                05520000
055300                                                                   05530000
055400     PERFORM PRINT-ERROR.                                          05540000
055500     GO TO NEXT-WORD.                                              05550000
055600                                                                   05560000
055700 COMPILE-AUGMENT.                                                  05570000
055800* THIS IS A TEMPORARY INSTRUCTION THAT ALLOWS MODIFICATION OF      05580000
055900* THE NEXT INSTRUCTION'S PARAMETERS                                05590000
056000                                                                   05600000
056100     MOVE TYPE-AUGMENT TO CELL-TYPE.                               05610000
056200     ADD 1 TO CELL-POINT.                                          05620000
056300                                                                   05630000
056400 CAU-1.                                                            05640000
056500     PERFORM READAWORD.                                            05650000
056600     IF WORD-CHAR (1) NOT = "L"                                    05660000
056700         SUBTRACT 1 FROM CELL-POINT                                05670000
056800         PERFORM STORE-CELL                                        05680000
056900         GO TO CHECK-WORD.                                         05690000
057000     PERFORM CONVERT-WORD-TO-BINARY.                               05700000
057100     IF NUMBER-N6 < 1 OR > 4                                       05710000
057200         GO TO PRINT-ERROR.                                        05720000
057300     MOVE NUMBER-N6 TO AUG-POINT.                                  05730000
057400     PERFORM READAWORD.                                            05740000
057500     IF WORD-16-CHAR = "WITH"                                      05750000
057600         PERFORM READAWORD.                                        05760000
057700     PERFORM CONVERT-LOCATION.                                     05770000
057800     IF LOC-LENGTH NOT = 4                                         05780000
057900         GO TO PRINT-ERROR.                                        05790000
058000     MOVE LOC-POINT TO CELL-WORD (AUG-POINT).                      05800000
058100     GO TO CAU-1.                                                  05810000
058200                                                                   05820000
058300 COMPILE-CALL.                                                     05830000
058400     MOVE TYPE-CALL TO CELL-TYPE.                                  05840000
058500     PERFORM READAWORD.                                            05850000
058600     IF WORD-16-CHAR = "M5DAEXPAND"                                05860000
058700         MOVE SUBR-M5DAEXPAND TO CELL-LOC2                         05870000
058800         PERFORM STORE-CELL                                        05880000
058900         GO TO NEXT-WORD.                                          05890000
059000     GO TO PRINT-ERROR.                                            05900000
059100                                                                   05910000
059200 COMPILE-DIVIDE.                                                   05920000
059300     MOVE TYPE-DIVIDE TO CELL-TYPE.                                05930000
059400     GO TO COMPILE-ARITHMETIC.                                     05940000
059500                                                                   05950000
059600 COMPILE-GO.                                                       05960000
059700     MOVE TYPE-GO TO CELL-TYPE.                                    05970000
059800     PERFORM READAWORD.                                            05980000
059900     IF WORD-2-CHAR = "TO" PERFORM READAWORD.                      05990000
060000     MOVE WORD-16-CHAR TO CELL-LABEL.                              06000000
060100     PERFORM STORE-CELL.                                           06010000
060200     GO TO NEXT-WORD.                                              06020000
060300                                                                   06030000
060400 COMPILE-ELSE.                                                     06040000
060500     MOVE TYPE-GO TO CELL-TYPE.                                    06050000
060600     ADD CELL-POINT 1 GIVING POYNT.                                06060000
060700     PERFORM SET-EXIT.                                             06070000
060800     PERFORM REQUEST-EXIT.                                         06080000
060900     PERFORM STORE-CELL.                                           06090000
061000     GO TO NEXT-WORD.                                              06100000
061100                                                                   06110000
061200 COMPILE-IF.                                                       06120000
061300     IF NEED-EXIT-POINT NOT ZERO                                   06130000
061400         GO TO PRINT-ERROR.                                        06140000
061500     MOVE ZERO TO AND-FLAG OR-FLAG.                                06150000
061600                                                                   06160000
061700 CI-CONDITION.                                                     06170000
061800     MOVE ZERO TO NOT-FLAG.                                        06180000
061900     PERFORM READAWORD.                                            06190000
062000     MOVE 1 TO LOC-FLAG.                                           06200000
062100     PERFORM CONVERT-LOCATION.                                     06210000
062200     IF LOC-FLAG = 2 AND CELL-LOC1 NOT ZERO                        06220000
062300         MOVE CELL-LOC1 TO LOC-POINT                               06230000
062400         MOVE CELL-NUM TO LOC-LENGTH                               06240000
062500         GO TO CI-RELATION.                                        06250000
062600     IF LOC-FLAG = 2                                               06260000
062700         GO TO PRINT-ERROR.                                        06270000
062800     PERFORM READAWORD.                                            06280000
062900                                                                   06290000
063000 CI-RELATION.                                                      06300000
063100     IF QUOTE-FLAG NOT ZERO                                        06310000
063200         GO TO CI-NOT-RELATION.                                    06320000
063300     IF WORD-2-CHAR = "IS" PERFORM READAWORD.                      06330000
063400     IF WORD-2-CHAR = "NO"                                         06340000
063500         MOVE 1 TO NOT-FLAG                                        06350000
063600         PERFORM READAWORD.                                        06360000
063700     IF WORD-CHAR (1) = "=" OR "E"                                 06370000
063800         MOVE TYPE-IF-EQUAL-CHARS TO CELL-TYPE                     06380000
063900         GO TO CI-1.                                               06390000
064000     IF WORD-2-CHAR = "GO"                                         06400000
064100         GO TO CI-NOT-RELATION.                                    06410000
064200     IF WORD-CHAR (1) = ">" OR "G"                                 06420000
064300         MOVE TYPE-IF-GREAT-CHARS TO CELL-TYPE                     06430000
064400         GO TO CI-1.                                               06440000
064500     IF WORD-CHAR (1) = "<" OR "L"                                 06450000
064600         MOVE TYPE-IF-LESS-CHARS TO CELL-TYPE                      06460000
064700         GO TO CI-1.                                               06470000
064800                                                                   06480000
064900 CI-NOT-RELATION.                                                  06490000
065000     IF CELL-TYPE = ZERO                                           06500000
065100         GO TO PRINT-ERROR.                                        06510000
065200     MOVE OR-FLAG TO NOT-FLAG.                                     06520000
065300     GO TO CI-2.                                                   06530000
065400                                                                   06540000
065500 CI-1.                                                             06550000
065600     MOVE LOC-POINT TO CELL-LOC1.                                  06560000
065700     MOVE LOC-LENGTH TO CELL-NUM.                                  06570000
065800     PERFORM READAWORD.                                            06580000
065900     IF WORD-CHAR (1) = "T" AND QUOTE-FLAG ZERO                    06590000
066000         PERFORM READAWORD.                                        06600000
066100     PERFORM CONVERT-LOCATION.                                     06610000
066200     PERFORM READAWORD.                                            06620000
066300                                                                   06630000
066400 CI-2.                                                             06640000
066500     MOVE LOC-POINT TO CELL-LOC2                                   06650000
066600     IF LOC-QUOTE-FLAG NOT ZERO                                    06660000
066700         MOVE LOC-LENGTH TO CELL-NUM.                              06670000
066800     IF WORD-2-CHAR = "OR" GO TO CI-OR.                            06680000
066900     IF WORD-2-CHAR = "AN" GO TO CI-AND.                           06690000
067000     GO TO CI-ACTION.                                              06700000
067100                                                                   06710000
067200 CI-OR.                                                            06720000
067300     IF AND-FLAG NOT ZERO GO TO PRINT-ERROR.                       06730000
067400     MOVE 1 TO OR-FLAG.                                            06740000
067500     IF NOT-FLAG = ZERO                                            06750000
067600         MOVE 1 TO NOT-FLAG                                        06760000
067700     ELSE                                                          06770000
067800         MOVE ZERO TO NOT-FLAG.                                    06780000
067900     GO TO CI-STORE.                                               06790000
068000                                                                   06800000
068100 CI-AND.                                                           06810000
068200     IF OR-FLAG NOT ZERO                                           06820000
068300         GO TO PRINT-ERROR.                                        06830000
068400     MOVE 1 TO AND-FLAG.                                           06840000
068500                                                                   06850000
068600 CI-STORE.                                                         06860000
068700     ADD NOT-FLAG TO CELL-TYPE.                                    06870000
068800     PERFORM REQUEST-EXIT.                                         06880000
068900     PERFORM STORE-CELL.                                           06890000
069000     GO TO CI-CONDITION.                                           06900000
069100                                                                   06910000
069200 CI-ACTION.                                                        06920000
069300     IF OR-FLAG ZERO                                               06930000
069400         GO TO CI-3.                                               06940000
069500     IF NOT-FLAG ZERO                                              06950000
069600         MOVE 1 TO NOT-FLAG                                        06960000
069700     ELSE                                                          06970000
069800         MOVE ZERO TO NOT-FLAG.                                    06980000
069900                                                                   06990000
070000 CI-3.                                                             07000000
070100     ADD NOT-FLAG TO CELL-TYPE.                                    07010000
070200     PERFORM REQUEST-EXIT.                                         07020000
070300     PERFORM STORE-CELL.                                           07030000
070400     IF OR-FLAG NOT ZERO                                           07040000
070500         ADD 1 CELL-POINT GIVING POYNT                             07050000
070600         PERFORM SET-EXIT                                          07060000
070700         MOVE ZERO TO CELL                                         07070000
070800         MOVE TYPE-GO TO CELL-TYPE                                 07080000
070900         PERFORM REQUEST-EXIT                                      07090000
071000         PERFORM STORE-CELL.                                       07100000
071100     GO TO CHECK-WORD.                                             07110000
071200                                                                   07120000
071300 COMPILE-IN.                                                       07130000
071400     MOVE OPEN-INPUT TO WORK-MODE.                                 07140000
071500                                                                   07150000
071600 COMPILE-FILE.                                                     07160000
071700     MOVE "MT" TO WORK-MEDIUM.                                     07170000
071800     MOVE "UT06-OUTPUT " TO WORK-NAME.                             07180000
071900     MOVE ZERO TO WORK-GEN.                                        07190000
072000     MOVE 2048 TO WORK-BLOCK.                                      07200000
072100                                                                   07210000
072200 CF-READ-WORD.                                                     07220000
072300     PERFORM READAWORD.                                            07230000
072400                                                                   07240000
072500 CF-TEST-WORD.                                                     07250000
072600     IF QUOTE-FLAG NOT ZERO                                        07260000
072700         MOVE WORD-AREA TO WORK-NAME                               07270000
072800         GO TO CF-READ-WORD.                                       07280000
072900     IF WORD-2-CHAR = "MT" OR "DA" OR "ED"                         07290000
073000         MOVE WORD-2-CHAR TO WORK-MEDIUM                           07300000
073100         PERFORM CONVERT-WORD-TO-BINARY                            07310000
073200         MOVE NUMBER-N6 TO WORK-FILE-NO                            07320000
073300         GO TO CF-READ-WORD.                                       07330000
073400     IF WORD-2-CHAR = "GE"                                         07340000
073500         PERFORM READAWORD                                         07350000
073600         PERFORM CONVERT-WORD-TO-BINARY                            07360000
073700         MOVE NUMBER-N6 TO WORK-GEN                                07370000
073800         GO TO CF-READ-WORD.                                       07380000
073900     IF WORD-2-CHAR = "BL"                                         07390000
074000         PERFORM READAWORD                                         07400000
074100         PERFORM CONVERT-WORD-TO-BINARY                            07410000
074200         MOVE NUMBER-N6 TO WORK-BLOCK                              07420000
074300         GO TO CF-READ-WORD.                                       07430000
074400     IF WORD-2-CHAR = "MT"                                         07440000
074500         GO TO CF-MT.                                              07450000
074600     IF WORK-MODE = OPEN-INPUT                                     07460000
074700         MOVE INPUT-DA TO WORK-TYPE                                07470000
074800     ELSE                                                          07480000
074900         MOVE OUTPUT-DA TO WORK-TYPE.                              07490000
075000     GO TO CF-END.                                                 07500000
075100                                                                   07510000
075200 CF-MT.                                                            07520000
075300     IF WORK-MODE = OPEN-INPUT                                     07530000
075400         MOVE INPUT-MT TO WORK-TYPE                                07540000
075500         GO TO CF-END.                                             07550000
075600     IF WORK-BLOCK > 512                                           07560000
075700         MOVE 2048 TO WORK-BLOCK                                   07570000
075800         MOVE OUTPUT-MT-2048 TO WORK-TYPE                          07580000
075900         GO TO CF-END.                                             07590000
076000     IF WORK-BLOCK > 124                                           07600000
076100         MOVE 512 TO WORK-BLOCK                                    07610000
076200         MOVE OUTPUT-MT-512 TO WORK-TYPE                           07620000
076300         GO TO CF-END.                                             07630000
076400     IF WORK-BLOCK > 64                                            07640000
076500         MOVE 128 TO WORK-BLOCK                                    07650000
076600         MOVE OUTPUT-MT-128 TO WORK-TYPE                           07660000
076700         GO TO CF-END.                                             07670000
076800     MOVE 64 TO WORK-BLOCK.                                        07680000
076900     MOVE OUTPUT-MT-64 TO WORK-TYPE.                               07690000
077000                                                                   07700000
077100 CF-END.                                                           07710000
077200     ADD 1 TO FILE-POINT.                                          07720000
077300     IF FILE-POINT > FILE-TABLE-SIZE                               07730000
077400         DISPLAY "ABANDON, TOO MANY FILES"                         07740000
077500         STOP 10.                                                  07750000
077600     MOVE WORK-FILE-DATA TO FILE-DATA (FILE-POINT).                07760000
077700     GO TO CHECK-WORD.                                             07770000
077800                                                                   07780000
077900 COMPILE-MOVE.                                                     07790000
078000     PERFORM READAWORD.                                            07800000
078100     PERFORM CONVERT-LOCATION.                                     07810000
078200     MOVE LOC-POINT TO CELL-LOC1.                                  07820000
078300     MOVE LOC-LENGTH TO CELL-NUM.                                  07830000
078400     PERFORM READAWORD.                                            07840000
078500     IF WORD-2-CHAR = "TO" PERFORM READAWORD.                      07850000
078600     PERFORM CONVERT-LOCATION.                                     07860000
078700     MOVE LOC-POINT TO CELL-LOC2.                                  07870000
078800     MOVE LOC-LENGTH TO CELL-EXIT.                                 07880000
078900     IF CELL-NUM > 0 AND LOC-LENGTH > 0                            07890000
079000         MOVE TYPE-MOVE-CHARS TO CELL-TYPE                         07900000
079100         GO TO COMPILE-MOVE-END.                                   07910000
079200     IF CELL-NUM = -4 AND LOC-LENGTH > 0 AND LOC-LENGTH < 7        07920000
079300         MOVE TYPE-MOVE-1B-D TO CELL-TYPE                          07930000
079400         GO TO COMPILE-MOVE-END.                                   07940000
079500     IF CELL-NUM > 0 AND CELL-NUM < 7 AND LOC-LENGTH = -4          07950000
079600         MOVE TYPE-MOVE-D-1B TO CELL-TYPE                          07960000
079700         GO TO COMPILE-MOVE-END.                                   07970000
079800     IF CELL-NUM = -4 AND LOC-LENGTH = -4                          07980000
079900         MOVE TYPE-MOVE-CHARS TO CELL-TYPE                         07990000
080000         MOVE 4 TO CELL-NUM.                                       08000000
080100     PERFORM PRINT-ERROR.                                          08010000
080200     GO TO NEXT-WORD.                                              08020000
080300                                                                   08030000
080400 COMPILE-MOVE-END.                                                 08040000
080500     PERFORM STORE-CELL.                                           08050000
080600     GO TO NEXT-WORD.                                              08060000
080700                                                                   08070000
080800 COMPILE-MULTIPLY.                                                 08080000
080900     MOVE TYPE-MULTIPLY TO CELL-TYPE.                              08090000
081000     GO TO COMPILE-ARITHMETIC.                                     08100000
081100                                                                   08110000
081200 COMPILE-OUT.                                                      08120000
081300     MOVE OPEN-OUTPUT TO WORK-MODE.                                08130000
081400     MOVE 1 TO OUT-MT-FLAG.                                        08140000
081500     GO TO COMPILE-FILE.                                           08150000
081600                                                                   08160000
081700 COMPILE-PERFORM.                                                  08170000
081800     MOVE TYPE-PERFORM TO CELL-TYPE.                               08180000
081900     PERFORM READAWORD.                                            08190000
082000     MOVE WORD-16-CHAR TO CELL-LABEL.                              08200000
082100     PERFORM STORE-CELL.                                           08210000
082200     GO TO NEXT-WORD.                                              08220000
082300                                                                   08230000
082400 COMPILE-PRINT.                                                    08240000
082500     MOVE TYPE-PRINT TO CELL-TYPE.                                 08250000
082600     PERFORM STORE-CELL.                                           08260000
082700     GO TO NEXT-WORD.                                              08270000
082800                                                                   08280000
082900 COMPILE-READ.                                                     08290000
083000     MOVE TYPE-READ TO CELL-TYPE.                                  08300000
083100     ADD 2 TO CELL-POINT.                                          08310000
083200     PERFORM READAWORD.                                            08320000
083300     IF WORD-16-CHAR = "CARD"                                      08330000
083400         MOVE 1 TO CELL-LOC2                                       08340000
083500         PERFORM READAWORD.                                        08350000
083600     IF WORD-CHAR (1) = "F"                                        08360000
083700         PERFORM CONVERT-WORD-TO-BINARY                            08370000
083800         MOVE NUMBER-N6 TO CELL-LOC1                               08380000
083900         PERFORM READAWORD.                                        08390000
084000     IF WORD-2-CHAR = "AT" PERFORM READAWORD.                      08400000
084100     SUBTRACT 2 FROM CELL-POINT.                                   08410000
084200     IF WORD-2-CHAR = "EN"                                         08420000
084300         PERFORM REQUEST-EXIT                                      08430000
084400         PERFORM STORE-CELL                                        08440000
084500         GO TO NEXT-WORD.                                          08450000
084600     ADD 2 CELL-POINT GIVING CELL-EXIT.                            08460000
084700     PERFORM STORE-CELL.                                           08470000
084800     MOVE ZERO TO CELL.                                            08480000
084900     MOVE TYPE-STOP TO CELL-TYPE.                                  08490000
085000     PERFORM STORE-CELL.                                           08500000
085100     GO TO CHECK-WORD.                                             08510000
085200                                                                   08520000
085300 COMPILE-STOP.                                                     08530000
085400     MOVE TYPE-STOP TO CELL-TYPE.                                  08540000
085500     PERFORM STORE-CELL.                                           08550000
085600     GO TO NEXT-WORD.                                              08560000
085700                                                                   08570000
085800 COMPILE-SUBTRACT.                                                 08580000
085900     MOVE TYPE-SUBTRACT TO CELL-TYPE.                              08590000
086000     GO TO COMPILE-ARITHMETIC.                                     08600000
086100                                                                   08610000
086200 COMPILE-WRITE.                                                    08620000
086300     MOVE 1 TO OUT-MT-FLAG.                                        08630000
086400     MOVE TYPE-WRITE TO CELL-TYPE.                                 08640000
086500     ADD 1 TO CELL-POINT.                                          08650000
086600     PERFORM READAWORD.                                            08660000
086700     IF WORD-CHAR (1) = "F"                                        08670000
086800         PERFORM CONVERT-WORD-TO-BINARY                            08680000
086900         MOVE NUMBER-N6 TO CELL-LOC1                               08690000
087000         PERFORM READAWORD.                                        08700000
087100     SUBTRACT 1 FROM CELL-POINT.                                   08710000
087200     PERFORM STORE-CELL.                                           08720000
087300     GO TO CHECK-WORD.                                             08730000
087400                                                                   08740000
087500 READAWORD SECTION.                                                08750000
087600                                                                   08760000
087700 READ-WORD.                                                        08770000
087800     IF FULL-STOP-FLAG NOT ZERO                                    08780000
087900     AND NEED-EXIT-POINT NOT ZERO                                  08790000
088000         MOVE CELL-POINT TO POYNT                                  08800000
088100         PERFORM SET-EXIT.                                         08810000
088200     MOVE ZERO TO FULL-STOP-FLAG.                                  08820000
088300     MOVE ZERO TO WORD-CHAR-POINT QUOTE-FLAG.                      08830000
088400     MOVE SPACES TO WORD-AREA.                                     08840000
088500                                                                   08850000
088600 RW-1.                                                             08860000
088700     IF END-CARDS-FLAG ZERO                                        08870000
088800         PERFORM READ-CHAR.                                        08880000
088900     IF END-CARDS-FLAG NOT ZERO                                    08890000
089000         MOVE 1 TO END-WORDS-FLAG FIRST-CHAR-POINT                 08900000
089100         GO TO RW-EXIT.                                            08910000
089200     IF QUOTE-FLAG = 1                                             08920000
089300         GO TO RW-2.                                               08930000
089400     IF END-CHAR-FLAG = 1                                          08940000
089500         GO TO RW-1.                                               08950000
089600     MOVE CARD-CHAR-POINT TO FIRST-CHAR-POINT.                     08960000
089700     IF WORK-CHAR = QUOTE                                          08970000
089800         MOVE 1 TO QUOTE-FLAG                                      08980000
089900         GO TO RW-1.                                               08990000
090000                                                                   09000000
090100 RW-2.                                                             09010000
090200     IF WORD-CHAR-POINT > 79                                       09020000
090300         PERFORM PRINT-ERROR                                       09030000
090400         GO TO RW-3.                                               09040000
090500     ADD 1 TO WORD-CHAR-POINT.                                     09050000
090600     MOVE WORK-CHAR TO WORD-CHAR (WORD-CHAR-POINT).                09060000
090700     IF CARD-CHAR-POINT = 80                                       09070000
090800         GO TO RW-EXIT.                                            09080000
090900                                                                   09090000
091000 RW-3.                                                             09100000
091100     PERFORM READ-CHAR.                                            09110000
091200     IF END-CARDS-FLAG = 1                                         09120000
091300         GO TO RW-EXIT.                                            09130000
091400     IF QUOTE-FLAG = ZERO AND END-CHAR-FLAG = 1                    09140000
091500         GO TO RW-EXIT.                                            09150000
091600     IF WORK-CHAR NOT = QUOTE                                      09160000
091700         GO TO RW-2.                                               09170000
091800                                                                   09180000
091900 RW-EXIT.                                                          09190000
092000     IF WORD-CHAR (WORD-CHAR-POINT) = "." AND QUOTE-FLAG ZERO      09200000
092100         MOVE 1 TO FULL-STOP-FLAG                                  09210000
092200         MOVE SPACE TO WORD-CHAR (WORD-CHAR-POINT)                 09220000
092300         SUBTRACT 1 FROM WORD-CHAR-POINT.                          09230000
092400     IF WORD-CHAR-POINT < 1 AND END-WORDS-FLAG ZERO                09240000
092500         GO TO READ-WORD.                                          09250000
092600                                                                   09260000
092700 SUBROUTINES SECTION.                                              09270000
092800                                                                   09280000
092900 READ-CHAR.                                                        09290000
093000     ADD 1 TO CARD-CHAR-POINT.                                     09300000
093100     IF CARD-CHAR-POINT > 80                                       09310000
093200         PERFORM READ-CARD                                         09320000
093300         MOVE 1 TO CARD-CHAR-POINT.                                09330000
093400     MOVE CARD-CHAR (CARD-CHAR-POINT) TO WORK-CHAR.                09340000
093500     IF WORK-CHAR = SPACE OR ","                                   09350000
093600         MOVE 1 TO END-CHAR-FLAG                                   09360000
093700     ELSE                                                          09370000
093800         MOVE ZERO TO END-CHAR-FLAG.                               09380000
093900                                                                   09390000
094000 READ-CARD.                                                        09400000
094100     IF LIST-CARD NOT = SPACES                                     09410000
094200         PERFORM PRINT.                                            09420000
094300     READ CARD-FILE                                                09430000
094400         AT END                                                    09440000
094500             MOVE 1 TO END-CARDS-FLAG                              09450000
094600             MOVE "****" TO CARD-RECORD.                           09460000
094700     MOVE CARD-RECORD TO LIST-CARD.                                09470000
094800     PERFORM PRINT.                                                09480000
094900                                                                   09490000
095000 REQUEST-EXIT.                                                     09500000
095100     IF NEED-EXIT-POINT ZERO                                       09510000
095200         MOVE CELL-POINT TO NEED-EXIT-POINT.                       09520000
095300     MOVE -200 TO CELL-EXIT.                                       09530000
095400                                                                   09540000
095500 SET-EXIT.                                                         09550000
095600     IF CELL-STORE-EXIT (NEED-EXIT-POINT) = -200                   09560000
095700         MOVE POYNT TO CELL-STORE-EXIT (NEED-EXIT-POINT).          09570000
095800     ADD 1 TO NEED-EXIT-POINT.                                     09580000
095900     IF NEED-EXIT-POINT < CELL-POINT                               09590000
096000         GO TO SET-EXIT.                                           09600000
096100     MOVE ZERO TO NEED-EXIT-POINT.                                 09610000
096200                                                                   09620000
096300 CREATE-RETURN-CELL.                                               09630000
096400     IF LABEL-FLAG NOT ZERO                                        09640000
096500          MOVE TYPE-EXIT TO CELL-TYPE                              09650000
096600          PERFORM STORE-CELL.                                      09660000
096700                                                                   09670000
096800 STORE-CELL.                                                       09680000
096900     MOVE CELL TO CELL-STORE (CELL-POINT).                         09690000
097000     ADD 1 TO CELL-POINT.                                          09700000
097100     IF CELL-POINT > NO-OF-CELLS                                   09710000
097200         DISPLAY "ABANDON, TOO MANY INSTRUCTIONS"                  09720000
097300         STOP 11.                                                  09730000
097400                                                                   09740000
097500 PRINT-ERROR.                                                      09750000
097600     MOVE 1 TO ERROR-FLAG.                                         09760000
097700     MOVE "+" TO LIST-CHAR (FIRST-CHAR-POINT).                     09770000
097800     MOVE "ERROR; WORD IGNORED" TO LIST-COMMENT.                   09780000
097900                                                                   09790000
098000 PRINT-ERROR-EXIT.                                                 09800000
098100     GO TO NEXT-WORD.                                              09810000
098200                                                                   09820000
098300 PRINT.                                                            09830000
098400     MOVE PRINT-LINE TO PRINT-AREA.                                09840000
098500*AJT CALL A510 USING A510-AREA.                                    09850000
098600*AJT - "A510" PRINT SUBROUTINE NOT YET SUPPORTED!                  09860000
098700      DISPLAY PRINT-AREA.                                          09870000
098800     MOVE "SP 1" TO A510-CONTROL.                                  09880000
098900     MOVE SPACES TO PRINT-LINE.                                    09890000
099000                                                                   09900000
099100 CONVERT-LOCATION SECTION.                                         09910000
099200                                                                   09920000
099300 READ-LOCATION.                                                    09930000
099400     MOVE ZERO TO CHAR-AREA-FLAG.                                  09940000
099500     IF LOC-FLAG = 2                                               09950000
099600         MOVE ZERO TO LOC-FLAG.                                    09960000
099700     MOVE 1 TO LOC-POINT POYNT.                                    09970000
099800     MOVE ZERO TO LOC-LENGTH.                                      09980000
099900     IF QUOTE-FLAG = 1                                             09990000
100000         GO TO STORE-LITERAL.                                      10000000
100100     IF WORD-CHAR (1) = "W"                                        10010000
100200         ADD WORK-AREA-START TO LOC-POINT                          10020000
100300         GO TO IGNORE-ALPHA.                                       10030000
100400     IF WORD-CHAR (1) = "R"                                        10040000
100500         GO TO IGNORE-ALPHA.                                       10050000
100600     IF WORD-CHAR (1) NUMERIC                                      10060000
100700         GO TO CREATE-BINARY-LITERAL.                              10070000
100800     IF WORD-CHAR (1) = "A"                                        10080000
100900         ADD A510-AREA-START TO LOC-POINT                          10090000
101000         GO TO IGNORE-ALPHA.                                       10100000
101100     MOVE 1 TO CHAR-AREA-FLAG.                                     10110000
101200     MOVE ZERO TO LOC-POINT.                                       10120000
101300     IF WORD-CHAR (1) = "C"                                        10130000
101400         ADD CARD-AREA-START TO LOC-POINT                          10140000
101500         GO TO IGNORE-ALPHA.                                       10150000
101600     IF WORD-CHAR (1) = "P"                                        10160000
101700         ADD PRINT-AREA-START TO LOC-POINT                         10170000
101800         GO TO IGNORE-ALPHA.                                       10180000
101900     IF WORD-CHAR (1) = "H"                                        10190000
102000         ADD H-HEAD-AREA-START TO LOC-POINT                        10200000
102100         GO TO IGNORE-ALPHA.                                       10210000
102200     IF WORD-CHAR (1) = "I"                                        10220000
102300         ADD I-HEAD-AREA-START TO LOC-POINT                        10230000
102400         GO TO IGNORE-ALPHA.                                       10240000
102500     IF WORD-CHAR (1) = "J"                                        10250000
102600         ADD J-HEAD-AREA-START TO LOC-POINT                        10260000
102700         GO TO IGNORE-ALPHA.                                       10270000
102800                                                                   10280000
102900 NOT-A-LOCATION.                                                   10290000
103000     IF LOC-FLAG = 1                                               10300000
103100         MOVE 2 TO LOC-FLAG                                        10310000
103200         GO TO RL-EXIT.                                            10320000
103300     PERFORM PRINT-ERROR.                                          10330000
103400     GO TO NEXT-WORD.                                              10340000
103500                                                                   10350000
103600 IGNORE-ALPHA.                                                     10360000
103700     IF POYNT > WORD-CHAR-POINT                                    10370000
103800         GO TO RL-EXIT.                                            10380000
103900     IF WORD-CHAR (POYNT) ALPHABETIC                               10390000
104000     OR WORD-CHAR (POYNT) = "+"                                    10400000
104100     OR WORD-CHAR (POYNT) = "-"                                    10410000
104200         ADD 1 TO POYNT                                            10420000
104300         GO TO IGNORE-ALPHA.                                       10430000
104400     IF WORD-CHAR (POYNT) = SPACE                                  10440000
104500         GO TO RL-EXIT.                                            10450000
104600     IF CHAR-AREA-FLAG = 1                                         10460000
104700         PERFORM CONVERT-NUMBER                                    10470000
104800         ADD NUMBER-N6 TO LOC-POINT.                               10480000
104900     IF WORD-CHAR (POYNT) NUMERIC                                  10490000
105000         PERFORM CONVERT-NUMBER                                    10500000
105100         COMPUTE NUMBER-N6 = NUMBER-N6 * 4                         10510000
105200         ADD NUMBER-N6 TO LOC-POINT.                               10520000
105300     IF WORD-CHAR (POYNT) = "."                                    10530000
105400     AND WORD-CHAR (WORD-CHAR-POINT) NOT = "B"                     10540000
105500         ADD 1 TO POYNT                                            10550000
105600         PERFORM CONVERT-NUMBER                                    10560000
105700         ADD NUMBER-N6 TO LOC-POINT.                               10570000
105800     IF WORD-CHAR (POYNT) = "/"                                    10580000
105900         ADD 1 TO POYNT                                            10590000
106000         PERFORM CONVERT-NUMBER                                    10600000
106100         MOVE NUMBER-N6 TO LOC-LENGTH.                             10610000
106200     IF WORD-CHAR (POYNT) = "B"                                    10620000
106300         DIVIDE 4 INTO LOC-POINT                                   10630000
106400         ADD 1 TO LOC-POINT                                        10640000
106500         GO TO RL-EXIT.                                            10650000
106600     IF WORD-CHAR (POYNT) NOT = SPACE                              10660000
106700         MOVE 2 TO LOC-FLAG                                        10670000
106800         GO TO NOT-A-LOCATION.                                     10680000
106900     GO TO RL-EXIT.                                                10690000
107000                                                                   10700000
107100 CREATE-BINARY-LITERAL.                                            10710000
107200* THIS CODE APPEARS TO ALIGN A BINARY LITERAL ON A WORD BOUNDARY   10720000
107300     MOVE LITERAL-CHAR-POINT TO WORK-2-BITS.                       10730000
107400     IF WORK-2-BITS NOT = 1                                        10740000
107500         ADD 1 TO LITERAL-CHAR-POINT                               10750000
107600         GO TO CREATE-BINARY-LITERAL.                              10760000
107700* AND IS PROBABLY NOT NEEDED                                       10770000
107800                                                                   10780000
107900     PERFORM CONVERT-WORD-TO-BINARY.                               10790000
108000     MOVE NUMBER-X4 TO WORD-AREA.                                  10800000
108100     MOVE 4 TO WORD-CHAR-POINT.                                    10810000
108200                                                                   10820000
108300 STORE-LITERAL.                                                    10830000
108400     MOVE ZERO TO LOC-LENGTH.                                      10840000
108500     MOVE LITERAL-CHAR-POINT TO LOC-POINT.                         10850000
108600     MOVE 1 TO POYNT.                                              10860000
108700                                                                   10870000
108800 SL-1.                                                             10880000
108900     IF LITERAL-CHAR-POINT > LITERAL-AREA-END                      10890000
109000         DISPLAY "ABANDON, LITERAL TABLE OVERFLOW".                10900000
109100         STOP 12.                                                  10910000
109200     IF POYNT > WORD-CHAR-POINT                                    10920000
109300         GO TO RL-EXIT.                                            10930000
109400     MOVE WORD-CHAR (POYNT) TO CHAR (LITERAL-CHAR-POINT).          10940000
109500     ADD 1 TO LITERAL-CHAR-POINT.                                  10950000
109600     ADD 1 TO POYNT.                                               10960000
109700     ADD 1 TO LOC-LENGTH.                                          10970000
109800     GO TO SL-1.                                                   10980000
109900                                                                   10990000
110000 RL-EXIT.                                                          11000000
110100     IF LOC-FLAG = 1                                               11010000
110200         MOVE ZERO TO LOC-FLAG.                                    11020000
110300     IF LOC-FLAG NOT = 2                                           11030000
110400         MOVE QUOTE-FLAG TO LOC-QUOTE-FLAG.                        11040000
110500     IF LOC-LENGTH = ZERO                                          11050000
110600         MOVE 4 TO LOC-LENGTH.                                     11060000
110700     IF WORD-CHAR (WORD-CHAR-POINT) = "B" AND QUOTE-FLAG = ZERO    11070000
110800         MULTIPLY -1 BY LOC-LENGTH.                                11080000
110900                                                                   11090000
111000 NUMERIC-CONVERSION SECTION.                                       11100000
111100                                                                   11110000
111200 CONVERT-WORD-TO-BINARY.                                           11120000
111300     MOVE WORD-AREA TO NUM-FIELD-X.                                11130000
111400     MOVE NUM-FIELD TO NUMBER-N6.                                  11140000
111500                                                                   11150000
111600 LOC-TO-BINARY.                                                    11160000
111700     IF LOC-LENGTH NOT = 4                                         11170000
111800         GO TO LTB-EXIT.                                           11180000
111900     MOVE LOC-POINT TO WORK-2-BITS.                                11190000
112000     IF WORK-2-BITS = 1                                            11200000
112100         DIVIDE 4 INTO LOC-POINT                                   11210000
112200         ADD 1 TO LOC-POINT                                        11220000
112300         MOVE -4 TO LOC-LENGTH.                                    11230000
112400                                                                   11240000
112500 LTB-EXIT.                                                         11250000
112600     EXIT.                                                         11260000
112700                                                                   11270000
112800 CONVERT-NUMBER SECTION.                                           11280000
112900                                                                   11290000
113000 CONVERT-NUM.                                                      11300000
113100     MOVE SPACES TO NUM-FIELD-X.                                   11310000
113200     MOVE 1 TO NUM-POINT.                                          11320000
113300                                                                   11330000
113400 CN-1.                                                             11340000
113500     IF WORD-CHAR (POYNT) NOT NUMERIC                              11350000
113600         GO TO CN-EXIT.                                            11360000
113700     MOVE WORD-CHAR (POYNT) TO NUM-CHAR (NUM-POINT).               11370000
113800     ADD 1 TO NUM-POINT.                                           11380000
113900     IF NUM-POINT > 6                                              11390000
114000         PERFORM PRINT-ERROR                                       11400000
114100         GO TO NEXT-WORD.                                          11410000
114200     ADD 1 TO POYNT.                                               11420000
114300     IF POYNT > 80                                                 11430000
114400         PERFORM PRINT-ERROR                                       11440000
114500         GO TO NEXT-WORD.                                          11450000
114600     GO TO CN-1.                                                   11460000
114700                                                                   11470000
114800 CN-EXIT.                                                          11480000
114900     MOVE NUM-FIELD TO NUMBER-N6.                                  11490000
115000                                                                   11500000
115100 CHECK-LABELS SECTION.                                             11510000
115200                                                                   11520000
115300 CL-0.                                                             11530000
115400     MOVE ZERO TO CELL-POINT.                                      11540000
115500                                                                   11550000
115600 CL-1.                                                             11560000
115700     ADD 1 TO CELL-POINT.                                          11570000
115800     IF CELL-POINT > TOTAL-CELLS                                   11580000
115900         MOVE ZERO TO CELL                                         11590000
116000         MOVE TYPE-GO TO CELL-TYPE                                 11600000
116100         MOVE 1 TO CELL-EXIT                                       11610000
116200         MOVE CELL TO CELL-STORE (CELL-POINT)                      11620000
116300         ADD 1 TO TOTAL-CELLS                                      11630000
116400         GO TO PRINT-CELLS.                                        11640000
116500     MOVE CELL-STORE (CELL-POINT) TO CELL.                         11650000
116600     IF CELL-TYPE NOT = TYPE-PERFORM AND CELL-TYPE NOT = TYPE-GO   11660000
116700         GO TO CL-1.                                               11670000
116800     IF CELL-LOC1 ZERO                                             11680000
116900         GO TO CL-1.                                               11690000
117000     MOVE ZERO TO POYNT.                                           11700000
117100                                                                   11710000
117200 CL-2.                                                             11720000
117300     ADD 1 TO POYNT.                                               11730000
117400     IF POYNT > TOTAL-CELLS                                        11740000
117500         MOVE "UNDEFINED LABEL" TO LIST-COMMENT                    11750000
117600         MOVE CELL-LABEL TO LIST-NAME                              11760000
117700         PERFORM PRINT                                             11770000
117800         MOVE 1 TO ERROR-FLAG                                      11780000
117900         GO TO CL-1.                                               11790000
118000     IF CELL-STORE-TYPE (POYNT) NOT = TYPE-LABEL                   11800000
118100         GO TO CL-2.                                               11810000
118200     IF CELL-STORE-LABEL (POYNT) NOT = CELL-LABEL                  11820000
118300         GO TO CL-2.                                               11830000
118400     MOVE ZERO TO CELL-LABEL.                                      11840000
118500     IF CELL-TYPE = TYPE-GO                                        11850000
118600         ADD 1 POYNT GIVING CELL-EXIT                              11860000
118700         GO TO CL-4.                                               11870000
118800     ADD 1 POYNT GIVING CELL-LOC1.                                 11880000
118900                                                                   11890000
119000 CL-3.                                                             11900000
119100     ADD 1 TO POYNT.                                               11910000
119200     IF POYNT > TOTAL-CELLS                                        11920000
119300         GO TO POST-MORTEM.                                        11930000
119400     IF CELL-STORE-TYPE (POYNT) NOT = TYPE-EXIT                    11940000
119500         GO TO CL-3.                                               11950000
119600     MOVE POYNT TO CELL-LOC2.                                      11960000
119700                                                                   11970000
119800 CL-4.                                                             11980000
119900     MOVE CELL TO CELL-STORE (CELL-POINT).                         11990000
120000     GO TO CL-1.                                                   12000000
120100                                                                   12010000
120200 PRINT-CELLS SECTION.                                              12020000
120300                                                                   12030000
120400 PC-0.                                                             12040000
120500     PERFORM PRINT 3 TIMES.                                        12050000
120600     MOVE "LISTING OF FILE DATA:" TO LIST-CARD.                    12060000
120700     PERFORM PRINT 2 TIMES.                                        12070000
120800     MOVE "FILE NO.  FILE NAME       GEN     BLOCK   TYPE    MODE" 12080000
120900             TO LIST-CARD.                                         12090000
121000     PERFORM PRINT 2 TIMES.                                        12100000
121100     MOVE ZERO TO POYNT.                                           12110000
121200                                                                   12120000
121300 PC-FILE.                                                          12130000
121400     ADD 1 TO POYNT.                                               12140000
121500     IF POYNT > FILE-POINT                                         12150000
121600         GO TO PC-CELLS.                                           12160000
121700     MOVE FILE-DATA (POYNT) TO WORK-FILE-DATA.                     12170000
121800     MOVE WORK-FILE-NO TO LIST-CELL.                               12180000
121900     MOVE WORK-NAME TO LIST-LABEL.                                 12190000
122000     MOVE WORK-GEN TO LIST-LOC1.                                   12200000
122100     MOVE WORK-BLOCK TO LIST-LOC2.                                 12210000
122200     MOVE WORK-TYPE TO LIST-NUM.                                   12220000
122300     MOVE WORK-MODE TO LIST-EXIT.                                  12230000
122400     PERFORM PRINT.                                                12240000
122500     GO TO PC-FILE.                                                12250000
122600                                                                   12260000
122700 PC-CELLS.                                                         12270000
122800     PERFORM PRINT 2 TIMES.                                        12280000
122900     MOVE "LISTING OF GENERATED INSTRUCTIONS:" TO LIST-CARD.       12290000
123000     PERFORM PRINT 2 TIMES.                                        12300000
123100     MOVE "ADDRESS   INSTRUCTION     LOC1    LOC2    SIZE    EXIT" 12310000
123200             TO LIST-CARD.                                         12320000
123300     PERFORM PRINT 2 TIMES.                                        12330000
123400     MOVE 1 TO CELL-POINT.                                         12340000
123500                                                                   12350000
123600 PC-1.                                                             12360000
123700     MOVE CELL-STORE (CELL-POINT) TO CELL.                         12370000
123800     MOVE CELL-POINT TO LIST-CELL.                                 12380000
123900     IF CELL-TYPE = TYPE-LABEL                                     12390000
124000         MOVE CELL-LABEL TO LIST-LABEL                             12400000
124100         GO TO PC-2.                                               12410000
124200     MOVE INSTRUCTION-NAME (CELL-TYPE) TO LIST-TYPE.               12420000
124300     MOVE CELL-LOC1 TO LIST-LOC1.                                  12430000
124400     MOVE CELL-LOC2 TO LIST-LOC2.                                  12440000
124500     MOVE CELL-NUM TO LIST-NUM.                                    12450000
124600     MOVE CELL-EXIT TO LIST-EXIT.                                  12460000
124700                                                                   12470000
124800 PC-2.                                                             12480000
124900     PERFORM PRINT.                                                12490000
125000     IF CELL-POINT < TOTAL-CELLS                                   12500000
125100         ADD 1 TO CELL-POINT                                       12510000
125200         GO TO PC-1.                                               12520000
125300     PERFORM PRINT 2 TIMES.                                        12530000
125400     MOVE "LISTING OF LITERAL TABLE:" TO LIST-CARD.                12540000
125500     PERFORM PRINT 2 TIMES.                                        12550000
125600     MOVE LITERAL-AREA TO PRINT-LINE.                              12560000
125700     PERFORM PRINT.                                                12570000
125800                                                                   12580000
125900 CHECK-ERROR.                                                      12590000
126000     IF ERROR-FLAG NOT ZERO                                        12600000
126100         DISPLAY "ABANDON, COMPILE ERROR"                          12610000
126200         STOP 13                                                   12620000
126300         GO TO CHECK-ERROR.                                        12630000
126400     MOVE 1 TO COMPILE-FLAG.                                       12640000
126500     IF HALT-AFTER-COMPILE                                         12650000
126600         PERFORM CLOSE-CARD-PRINTER                                12660000
126700         DISPLAY "ACTION, COMPILED OK"                             12670000
126800         STOP 14                                                   12680000
126900     ELSE                                                          12690000
127000         DISPLAY "COMPILED OK".                                    12700000
127100                                                                   12710000
127200 RUN-GENERATED-PROGRAM SECTION.                                    12720000
127300                                                                   12730000
127400 RUN-INITIALISE.                                                   12740000
127500     PERFORM OPEN-CARD-PRINTER.                                    12750000
127600     MOVE ZERO                   TO RECORD-AREA                    12760000
127700     MOVE ZERO                   TO WORK-AREA                      12770000
127800     MOVE ZERO                   TO A510-PAGE                      12780000
127900     MOVE ZERO                   TO FILE-STATUS-TABLE              12790000
128000     MOVE ZERO                   TO IN-FILE-POINT                  12800000
128100     MOVE ZERO                   TO OUT-FILE-POINT                 12810000
128200     MOVE ZERO                   TO TOTALS.                        12820000
128300     MOVE SPACES                 TO CARD-AREA PRINT-AREA.          12830000
128400     MOVE 100                    TO A510-LINES-THIS.               12840000
128500     MOVE SPACES                 TO HEAD-1-COM.                    12850000
128600     IF OUT-MT-FLAG = 1 AND TOTAL-CELLS = 1                        12860000
128700         MOVE OPEN-OUTPUT        TO MODE-REQUIRED                  12870000
128800         PERFORM OPEN-FILE                                         12880000
128900         GO TO CLOSE-FILES.                                        12890000
129000     MOVE ZERO                   TO CELL-POINT.                    12900000
129100                                                                   12910000
129200 NEXT-CELL.                                                        12920000
129300     ADD 1 TO CELL-POINT.                                          12930000
129400                                                                   12940000
129500 ACTION-CELL.                                                      12950000
129600     MOVE CELL-STORE (CELL-POINT) TO CELL.                         12960000
129700                                                                   12970000
129800 BRANCH-ON-CELL-TYPE.                                              12980000
129900     GO TO                                                         12990000
130000             RUN-ADD                                               13000000
130100             RUN-AUGMENT                                           13010000
130200             RUN-CALL                                              13020000
130300             RUN-DIVIDE                                            13030000
130400             RUN-EXIT                                              13040000
130500             RUN-GO                                                13050000
130600             RUN-IF-EQUAL-CHARS                                    13060000
130700             RUN-IF-NOT-EQUAL-CHARS                                13070000
130800             RUN-IF-GREAT-CHARS                                    13080000
130900             RUN-IF-NOT-GREAT-CHARS                                13090000
131000             RUN-IF-LESS-CHARS                                     13100000
131100             RUN-IF-NOT-LESS-CHARS                                 13110000
131200             NEXT-CELL                                             13120000
131300             RUN-MOVE-1B-D                                         13130000
131400             RUN-MOVE-CHARS                                        13140000
131500             RUN-MOVE-D-1B                                         13150000
131600             RUN-MULTIPLY                                          13160000
131700             RUN-PERFORM                                           13170000
131800             RUN-PRINT                                             13180000
131900             RUN-READ                                              13190000
132000             RUN-STOP                                              13200000
132100             RUN-SUBTRACT                                          13210000
132200             RUN-WRITE                                             13220000
132300     DEPENDING ON CELL-TYPE.                                       13230000
132400                                                                   13240000
132500 POST-MORTEM.                                                      13250000
132600     DISPLAY "ADDRESS" CELL-POINT.                                 13260000
132700     DISPLAY "ABANDON PM".                                         13270000
132800     STOP 15.                                                      13280000
132900     GO TO POST-MORTEM.                                            13290000
133000                                                                   13300000
133100 RUN-ADD.                                                          13310000
133200     ADD BINARY-WORD (CELL-LOC1) TO BINARY-WORD (CELL-LOC2).       13320000
133300     GO TO NEXT-CELL.                                              13330000
133400                                                                   13340000
133500 RUN-AUGMENT.                                                      13350000
133600     MOVE CELL-LABEL TO AUG-STORE.                                 13360000
133700     ADD 1 TO CELL-POINT.                                          13370000
133800     MOVE CELL-STORE (CELL-POINT) TO CELL.                         13380000
133900     MOVE ZERO TO AUG-POINT.                                       13390000
134000                                                                   13400000
134100 RAU-1.                                                            13410000
134200     ADD 1 TO AUG-POINT.                                           13420000
134300     IF AUG-POINT > 4                                              13430000
134400         GO TO BRANCH-ON-CELL-TYPE.                                13440000
134500     MOVE AUG-WORD (AUG-POINT) TO ONE-LOC.                         13450000
134600     IF ONE-LOC = ZERO                                             13460000
134700         GO TO RAU-1.                                              13470000
134800     ENTER PLAN MOVECHAR USING ONE-WORD-MOVE IN-RECORD.            13480000
134900                                                                   13490000
135000* SORRY I HAVE NO IDEA WHAT THIS IS DOING!                         13500000
135100* IT OUGHT TO BE INCREMENTING THE NEXT INSTRUCTIONS'S PARAMETERS   13510000
135200* WITH A SET OF VARIABLES                                          13520000
135300                                                                   13530000
135400     IF SCR-WORD > 800                                             13540000
135500         DISPLAY "ABANDON, MOD OUT OF RANGE"                       13550000
135600         STOP 16.                                                  13560000
135700     ADD SCR-WORD TO CELL-WORD (AUG-POINT).                        13570000
135800     GO TO RAU-1.                                                  13580000
135900                                                                   13590000
136000 RUN-CALL.                                                         13600000
136100*    IF CELL-LOC1 = SUBR-M5DAEXPAND                                13610000
136200*        ENTER PLAN M5DAEXPAND USING M5DA-INDEX-BITS.              13620000
136300*AJT - CALLING "SUBR-M5DAEXPAND" NOT SUPPORTED!                    13630000
136400     GO TO NEXT-CELL.                                              13640000
136500                                                                   13650000
136600 RUN-DIVIDE.                                                       13660000
136700     DIVIDE BINARY-WORD (CELL-LOC1) INTO BINARY-WORD (CELL-LOC2).  13670000
136800     GO TO NEXT-CELL.                                              13680000
136900                                                                   13690000
137000 RUN-EXIT.                                                         13700000
137100     IF CELL-EXIT ZERO                                             13710000
137200         GO TO NEXT-CELL.                                          13720000
137300     MOVE ZERO TO CELL-STORE-EXIT (CELL-POINT).                    13730000
137400     MOVE CELL-EXIT TO CELL-POINT.                                 13740000
137500     GO TO ACTION-CELL.                                            13750000
137600                                                                   13760000
137700 RUN-GO.                                                           13770000
137800     MOVE CELL-EXIT TO CELL-POINT.                                 13780000
137900     GO TO ACTION-CELL.                                            13790000
138000                                                                   13800000
138100 RUN-IF-EQUAL-CHARS.                                               13810000
138200     IF CELL-NUM = ZERO                                            13820000
138300         GO TO NEXT-CELL.                                          13830000
138400     IF CHAR (CELL-LOC1) = CHAR (CELL-LOC2)                        13840000
138500         ADD 1 TO CELL-LOC1                                        13850000
138600         ADD 1 TO CELL-LOC2                                        13860000
138700         SUBTRACT 1 FROM CELL-NUM                                  13870000
138800         GO TO RUN-IF-EQUAL-CHARS.                                 13880000
138900     GO TO RUN-IF-FAIL.                                            13890000
139000                                                                   13900000
139100 RUN-IF-GREAT-CHARS.                                               13910000
139200     IF CELL-NUM = ZERO                                            13920000
139300         GO TO RUN-IF-FAIL.                                        13930000
139400     IF CHAR (CELL-LOC1) > CHAR (CELL-LOC2)                        13940000
139500         GO TO NEXT-CELL.                                          13950000
139600     IF CHAR (CELL-LOC1) = CHAR (CELL-LOC2)                        13960000
139700         ADD 1 TO CELL-LOC1                                        13970000
139800         ADD 1 TO CELL-LOC2                                        13980000
139900         SUBTRACT 1 FROM CELL-NUM                                  13990000
140000         GO TO RUN-IF-GREAT-CHARS.                                 14000000
140100     GO TO RUN-IF-FAIL.                                            14010000
140200                                                                   14020000
140300 RUN-IF-LESS-CHARS.                                                14030000
140400     IF CELL-NUM = ZERO                                            14040000
140500         GO TO RUN-IF-FAIL.                                        14050000
140600     IF CHAR (CELL-LOC1) < CHAR (CELL-LOC2)                        14060000
140700         GO TO NEXT-CELL.                                          14070000
140800     IF CHAR (CELL-LOC1) = CHAR (CELL-LOC2)                        14080000
140900         ADD 1 TO CELL-LOC1                                        14090000
141000         ADD 1 TO CELL-LOC2                                        14100000
141100         SUBTRACT 1 FROM CELL-NUM                                  14110000
141200         GO TO RUN-IF-LESS-CHARS.                                  14120000
141300     GO TO RUN-IF-FAIL.                                            14130000
141400                                                                   14140000
141500 RUN-IF-FAIL.                                                      14150000
141600     MOVE CELL-EXIT TO CELL-POINT.                                 14160000
141700     GO TO ACTION-CELL.                                            14170000
141800                                                                   14180000
141900 RUN-IF-NOT-EQUAL-CHARS.                                           14190000
142000     SUBTRACT 1 FROM CELL-EXIT GIVING POYNT.                       14200000
142100     ADD 1 CELL-POINT GIVING CELL-EXIT.                            14210000
142200     MOVE POYNT TO CELL-POINT.                                     14220000
142300     GO TO RUN-IF-EQUAL-CHARS.                                     14230000
142400                                                                   14240000
142500 RUN-IF-NOT-GREAT-CHARS.                                           14250000
142600     SUBTRACT 1 FROM CELL-EXIT GIVING POYNT.                       14260000
142700     ADD 1 CELL-POINT GIVING CELL-EXIT.                            14270000
142800     MOVE POYNT TO CELL-POINT.                                     14280000
142900     GO TO RUN-IF-GREAT-CHARS.                                     14290000
143000                                                                   14300000
143100 RUN-IF-NOT-LESS-CHARS.                                            14310000
143200     SUBTRACT 1 FROM CELL-EXIT GIVING POYNT.                       14320000
143300     ADD 1 CELL-POINT GIVING CELL-EXIT.                            14330000
143400     MOVE POYNT TO CELL-POINT.                                     14340000
143500     GO TO RUN-IF-LESS-CHARS.                                      14350000
143600                                                                   14360000
143700 RUN-MOVE-1B-D.                                                    14370000
143800* CONVERTS A BINARY WORD TO DISPLAY                                14380000
143900     MOVE BINARY-WORD (CELL-LOC1) TO NUM-FIELD.                    14390000
144000     SUBTRACT CELL-EXIT FROM 7 GIVING POYNT.                       14400000
144100                                                                   14410000
144200 RMBD-MOVE.                                                        14420000
144300     IF CELL-EXIT < 1                                              14430000
144400         GO TO NEXT-CELL.                                          14440000
144500     MOVE NUM-CHAR (POYNT) TO CHAR (CELL-LOC2).                    14450000
144600     ADD 1 TO POYNT.                                               14460000
144700     ADD 1 TO CELL-LOC2.                                           14470000
144800     SUBTRACT 1 FROM CELL-EXIT.                                    14480000
144900     GO TO RMBD-MOVE.                                              14490000
145000                                                                   14500000
145100 RUN-MOVE-CHARS.                                                   14510000
145200* SUBROUTINE MOVECHAR USED FOR EFFICIENCY ONLY                     14520000
145300*    ENTER PLAN MOVECHAR USING CELL-LOC1 IN-RECORD.                14530000
145400*    GO TO NEXT-CELL.                                              14540000
145500     IF CELL-NUM = ZERO                                            14550000
145600         GO TO NEXT-CELL.                                          14560000
145700     MOVE CHAR (CELL-LOC1) TO CHAR (CELL-LOC2).                    14570000
145800     ADD 1 TO CELL-LOC1.                                           14580000
145900     ADD 1 TO CELL-LOC2.                                           14590000
146000     SUBTRACT 1 FROM CELL-NUM.                                     14600000
146100     GO TO RUN-MOVE-CHARS.                                         14610000
146200                                                                   14620000
146300 RUN-MOVE-D-1B.                                                    14630000
146400* CONVERTS DISPLAY NUMERICS TO BINARY                              14640000
146500     MOVE SPACES TO NUM-FIELD-X.                                   14650000
146600     SUBTRACT CELL-NUM FROM 7 GIVING POYNT.                        14660000
146700                                                                   14670000
146800 RMDB-MOVE.                                                        14680000
146900     MOVE CHAR (CELL-LOC1) TO NUM-CHAR (POYNT).                    14690000
147000     ADD 1 TO CELL-LOC1.                                           14700000
147100     ADD 1 TO POYNT.                                               14710000
147200     SUBTRACT 1 FROM CELL-NUM.                                     14720000
147300     IF CELL-NUM > 0                                               14730000
147400         GO TO RMDB-MOVE.                                          14740000
147500     MOVE NUM-FIELD TO BINARY-WORD (CELL-LOC2).                    14750000
147600     GO TO NEXT-CELL.                                              14760000
147700                                                                   14770000
147800 RUN-MULTIPLY.                                                     14780000
147900     MULTIPLY BINARY-WORD (CELL-LOC1) BY BINARY-WORD (CELL-LOC2).  14790000
148000     GO TO NEXT-CELL.                                              14800000
148100                                                                   14810000
148200 RUN-PERFORM.                                                      14820000
148300     ADD 1 CELL-POINT GIVING CELL-STORE-EXIT (CELL-LOC2).          14830000
148400     MOVE CELL-LOC1 TO CELL-POINT.                                 14840000
148500     GO TO ACTION-CELL.                                            14850000
148600                                                                   14860000
148700* A510 IS A GENERAL PRINTING ROUTINE THAT HANDLES HEADINGS ETC     14870000
148800 RUN-PRINT.                                                        14880000
148900*    CALL A510 USING A510-AREA.                                    14890000
149000*AJT - "A510" PRINTING SUBROUTINE NOT YET SUPPORTED!               14900000
149100      DISPLAY PRINT-AREA.                                          14910000
149200     MOVE SPACES TO PRINT-AREA.                                    14920000
149300     GO TO NEXT-CELL.                                              14930000
149400                                                                   14940000
149500 RUN-READ.                                                         14950000
149600     IF CELL-LOC2 NOT ZERO                                         14960000
149700         GO TO RR-CARD.                                            14970000
149800     IF IN-FILE-POINT ZERO                                         14980000
149900         MOVE OPEN-INPUT TO MODE-REQUIRED                          14990000
150000         GO TO RR-OPEN.                                            15000000
150100     IF CELL-LOC1 = IN-FILE-NO                                     15010000
150200         GO TO RR-READ.                                            15020000
150300     MOVE OPEN-INPUT TO MODE-REQUIRED.                             15030000
150400     PERFORM CLOSE-FILE.                                           15040000
150500                                                                   15050000
150600 RR-OPEN.                                                          15060000
150700     PERFORM OPEN-FILE.                                            15070000
150800     IF END-FILE-FLAG NOT ZERO                                     15080000
150900         GO TO NEXT-CELL.                                          15090000
151000                                                                   15100000
151100 RR-READ.                                                          15110000
151200     IF IN-TYPE = INPUT-DA                                         15120000
151300         READ IN-DA                                                15130000
151400             AT END GO TO RUN-READ-END.                            15140000
151500     IF IN-TYPE = INPUT-MT                                         15150000
151600         READ IN-MT                                                15160000
151700             AT END GO TO RUN-READ-END.                            15170000
151800     ADD 1 TO RECS-IN.                                             15180000
151900     IF RECORD-WORD-COUNT > 200                                    15190000
152000         DISPLAY "ABANDON, RECORD TOO LONG"                        15200000
152100         STOP 17.                                                  15210000
152200                                                                   15220000
152300 RR-NEXT.                                                          15230000
152400     MOVE CELL-EXIT TO CELL-POINT.                                 15240000
152500     GO TO ACTION-CELL.                                            15250000
152600                                                                   15260000
152700 RR-CARD.                                                          15270000
152800     READ CARD-FILE                                                15280000
152900             AT END GO TO NEXT-CELL.                               15290000
153000     MOVE CARD-RECORD TO CARD-AREA.                                15300000
153100     GO TO RR-NEXT.                                                15310000
153200                                                                   15320000
153300 RUN-READ-END.                                                     15330000
153400     MOVE OPEN-INPUT TO MODE-REQUIRED.                             15340000
153500     PERFORM CLOSE-FILE.                                           15350000
153600     PERFORM OPEN-FILE.                                            15360000
153700     IF END-FILE-FLAG NOT ZERO                                     15370000
153800         GO TO NEXT-CELL.                                          15380000
153900     GO TO RUN-READ.                                               15390000
154000                                                                   15400000
154100 RUN-STOP.                                                         15410000
154200     GO TO CLOSE-FILES.                                            15420000
154300                                                                   15430000
154400 RUN-SUBTRACT.                                                     15440000
154500     SUBTRACT BINARY-WORD (CELL-LOC1) FROM BINARY-WORD (CELL-LOC2).15450000
154600     GO TO NEXT-CELL.                                              15460000
154700                                                                   15470000
154800 RUN-WRITE.                                                        15480000
154900     MOVE RECORD-WORD-COUNT TO NUMBER-N6.                          15490000
155000     IF OUT-FILE-POINT ZERO                                        15500000
155100         MOVE OPEN-OUTPUT TO MODE-REQUIRED                         15510000
155200         GO TO RW-OPEN.                                            15520000
155300     IF CELL-LOC1 = OUT-FILE-NO                                    15530000
155400         GO TO RW-WRITE.                                           15540000
155500     MOVE OPEN-OUTPUT TO MODE-REQUIRED.                            15550000
155600     PERFORM CLOSE-FILE.                                           15560000
155700                                                                   15570000
155800 RW-OPEN.                                                          15580000
155900     PERFORM OPEN-FILE.                                            15590000
156000                                                                   15600000
156100 RW-WRITE.                                                         15610000
156200     MOVE NUMBER-N6 TO RECORD-WORD-COUNT.                          15620000
156300     IF OUT-TYPE = OUTPUT-DA                                       15630000
156400         WRITE OUT-DA-REC                                          15640000
156500         PERFORM OUT-REPLY-CHECK                                   15650000
156600         GO TO RUN-WRITE-END.                                      15660000
156700     IF OUT-TYPE = OUTPUT-MT-2048                                  15670000
156800         WRITE OUT-MT-2048-REC                                     15680000
156900         GO TO RUN-WRITE-END.                                      15690000
157000     IF OUT-TYPE = OUTPUT-MT-512                                   15700000
157100         WRITE OUT-MT-512-REC                                      15710000
157200         GO TO RUN-WRITE-END.                                      15720000
157300     IF OUT-TYPE = OUTPUT-MT-128                                   15730000
157400         WRITE OUT-MT-128-REC                                      15740000
157500         GO TO RUN-WRITE-END.                                      15750000
157600     IF OUT-TYPE = OUTPUT-MT-64                                    15760000
157700         WRITE OUT-MT-64-REC.                                      15770000
157800                                                                   15780000
157900 RUN-WRITE-END.                                                    15790000
158000     MOVE NUMBER-N6 TO RECORD-WORD-COUNT.                          15800000
158100     ADD 1 TO RECS-OUT.                                            15810000
158200     GO TO NEXT-CELL.                                              15820000
158300                                                                   15830000
158400 CLOSE-FILES.                                                      15840000
158500     PERFORM CLOSE-CARD-PRINTER.                                   15850000
158600     MOVE OPEN-INPUT TO MODE-REQUIRED.                             15860000
158700     PERFORM CLOSE-FILE.                                           15870000
158800     MOVE OPEN-OUTPUT TO MODE-REQUIRED.                            15880000
158900     PERFORM CLOSE-FILE.                                           15890000
159000     IF RECS-IN NOT ZERO                                           15900000
159100         DISPLAY "IN " RECS-IN.                                    15910000
159200     IF RECS-OUT NOT ZERO                                          15920000
159300         DISPLAY "OUT " RECS-OUT.                                  15930000
159400     STOP RUN.                                                     15940000
159500                                                                   15950000
159600 OPEN-FILE SECTION.                                                15960000
159700                                                                   15970000
159800 OF-INITIALISE.                                                    15980000
159900     MOVE ZERO TO FILE-POINT END-FILE-FLAG.                        15990000
160000                                                                   16000000
160100 OF-NEXT-FILE.                                                     16010000
160200     ADD 1 TO FILE-POINT.                                          16020000
160300     IF FILE-POINT > FILE-TABLE-SIZE                               16030000
160400         MOVE 1 TO END-FILE-FLAG                                   16040000
160500         GO TO OF-EXIT.                                            16050000
160600                                                                   16060000
160700     MOVE FILE-DATA (FILE-POINT) TO WORK-FILE-DATA.                16070000
160800     IF WORK-MODE NOT = MODE-REQUIRED                              16080000
160900     OR WORK-FILE-NO NOT = CELL-LOC1                               16090000
161000     OR FILE-STATUS-FLAG (FILE-POINT) NOT ZERO                     16100000
161100         GO TO OF-NEXT-FILE.                                       16110000
161200     MOVE 1 TO FILE-STATUS-FLAG (FILE-POINT).                      16120000
161300     IF MODE-REQUIRED = OPEN-INPUT                                 16130000
161400         GO TO OF-INPUT.                                           16140000
161500                                                                   16150000
161600 OF-OUTPUT.                                                        16160000
161700     MOVE WORK-FILE-DATA TO OUT-FILE-DATA.                         16170000
161800     MOVE FILE-POINT TO OUT-FILE-POINT.                            16180000
161900                                                                   16190000
162000 OF-OUTPUT-DA.                                                     16200000
162100     IF OUT-TYPE > FILE-TYPE-DA                                    16210000
162200         GO TO OF-OUTPUT-MT.                                       16220000
162300     IF OUT-TYPE = OUTPUT-DA                                       16230000
162400         OPEN OUTPUT OUT-DA                                        16240000
162500         GO TO OF-TEST-OUT-REPLY.                                  16250000
162600     GO TO OF-ABANDON.                                             16260000
162700                                                                   16270000
162800 OF-TEST-OUT-REPLY.                                                16280000
162900     IF REPLY-WORD NOT ZERO                                        16290000
163000         DISPLAY "FILE " OUT-NAME " REPLY " REPLY-WORD             16300000
163100         GO TO OF-OUTPUT-DA.                                       16310000
163200     DISPLAY "ED " OUT-NAME " OPEN OUTPUT".                        16320000
163300     GO TO OF-EXIT.                                                16330000
163400                                                                   16340000
163500 OF-OUTPUT-MT.                                                     16350000
163600     IF OUT-TYPE = OUTPUT-MT-2048                                  16360000
163700         OPEN OUTPUT OUT-MT-2048                                   16370000
163800         GO TO OF-EXIT.                                            16380000
163900     IF OUT-TYPE = OUTPUT-MT-512                                   16390000
164000         OPEN OUTPUT OUT-MT-512                                    16400000
164100         GO TO OF-EXIT.                                            16410000
164200     IF OUT-TYPE = OUTPUT-MT-128                                   16420000
164300         OPEN OUTPUT OUT-MT-128                                    16430000
164400         GO TO OF-EXIT.                                            16440000
164500     IF OUT-TYPE = OUTPUT-MT-64                                    16450000
164600         OPEN OUTPUT OUT-MT-64                                     16460000
164700         GO TO OF-EXIT.                                            16470000
164800     GO TO OF-ABANDON.                                             16480000
164900                                                                   16490000
165000 OF-INPUT.                                                         16500000
165100     MOVE WORK-FILE-DATA TO IN-FILE-DATA.                          16510000
165200     MOVE FILE-POINT TO IN-FILE-POINT.                             16520000
165300                                                                   16530000
165400 OF-INPUT-DA.                                                      16540000
165500     IF IN-TYPE > FILE-TYPE-DA                                     16550000
165600         GO TO OF-INPUT-MT.                                        16560000
165700     IF IN-TYPE = INPUT-DA                                         16570000
165800         OPEN INPUT IN-DA                                          16580000
165900         GO TO OF-TEST-IN-REPLY.                                   16590000
166000     GO TO OF-ABANDON.                                             16600000
166100                                                                   16610000
166200 OF-TEST-IN-REPLY.                                                 16620000
166300     IF REPLY-WORD NOT ZERO                                        16630000
166400         DISPLAY "FILE " IN-NAME " REPLY " REPLY-WORD              16640000
166500         GO TO OF-INPUT-DA.                                        16650000
166600     DISPLAY "ED " IN-NAME " OPEN INPUT".                          16660000
166700     GO TO OF-EXIT.                                                16670000
166800                                                                   16680000
166900 OF-INPUT-MT.                                                      16690000
167000     IF IN-TYPE = INPUT-MT                                         16700000
167100         OPEN INPUT IN-MT                                          16710000
167200         GO TO OF-EXIT.                                            16720000
167300                                                                   16730000
167400 OF-ABANDON.                                                       16740000
167500     DISPLAY "ABANDON, FILE NOT SPECIFIED".                        16750000
167600     STOP 18.                                                      16760000
167700                                                                   16770000
167800 OF-EXIT.                                                          16780000
167900     IF END-FILE-FLAG NOT ZERO                                     16790000
168000     AND MODE-REQUIRED NOT = OPEN-INPUT                            16800000
168100         GO TO OF-ABANDON.                                         16810000
168200                                                                   16820000
168300 CLOSE-FILE SECTION.                                               16830000
168400                                                                   16840000
168500 CLF-INITIALISE.                                                   16850000
168600     MOVE ZERO TO REPLY-WORD.                                      16860000
168700     IF MODE-REQUIRED = OPEN-INPUT                                 16870000
168800         MOVE IN-FILE-POINT TO FILE-POINT                          16880000
168900     ELSE                                                          16890000
169000         MOVE OUT-FILE-POINT TO FILE-POINT.                        16900000
169100     IF FILE-POINT ZERO                                            16910000
169200         GO TO CLF-EXIT.                                           16920000
169300     IF FILE-STATUS-FLAG (FILE-POINT) NOT = 1                      16930000
169400         GO TO CLF-EXIT.                                           16940000
169500     MOVE 2 TO FILE-STATUS-FLAG (FILE-POINT).                      16950000
169600     MOVE FILE-DATA (FILE-POINT) TO WORK-FILE-DATA.                16960000
169700                                                                   16970000
169800 CLF-CLOSE.                                                        16980000
169900     IF WORK-TYPE = INPUT-DA                                       16990000
170000         CLOSE IN-DA                                               17000000
170100         GO TO CLF-EXIT.                                           17010000
170200     IF WORK-TYPE = OUTPUT-DA                                      17020000
170300         CLOSE OUT-DA                                              17030000
170400         GO TO CLF-EXIT.                                           17040000
170500     IF WORK-TYPE = INPUT-MT                                       17050000
170600         CLOSE IN-MT                                               17060000
170700         GO TO CLF-EXIT.                                           17070000
170800     IF WORK-TYPE = OUTPUT-MT-2048                                 17080000
170900         CLOSE OUT-MT-2048                                         17090000
171000         GO TO CLF-EXIT.                                           17100000
171100     IF WORK-TYPE = OUTPUT-MT-512                                  17110000
171200         CLOSE OUT-MT-512                                          17120000
171300         GO TO CLF-EXIT.                                           17130000
171400     IF WORK-TYPE = OUTPUT-MT-128                                  17140000
171500         CLOSE OUT-MT-128                                          17150000
171600         GO TO CLF-EXIT.                                           17160000
171700     IF WORK-TYPE = OUTPUT-MT-64                                   17170000
171800         CLOSE OUT-MT-64                                           17180000
171900         GO TO CLF-EXIT.                                           17190000
172000     DISPLAY "ABANDON CLF".                                        17200000
172100     STOP 19.                                                      17210000
172200                                                                   17220000
172300 CLF-EXIT.                                                         17230000
172400     IF REPLY-WORD NOT ZERO                                        17240000
172500         DISPLAY "FILE " WORK-NAME " REPLY " REPLY-WORD            17250000
172600         DISPLAY "ABANDON ON CLOSE".                               17260000
172700         STOP 20.                                                  17270000
172800                                                                   17280000
172900 RUN-TIME-SUBROUTNES SECTION.                                      17290000
173000                                                                   17300000
173100 OPEN-CARD-PRINTER.                                                17310000
173200     IF CARD-PRINTER-FLAG EQUAL ZERO                               17320000
173300         MOVE 1 TO CARD-PRINTER-FLAG                               17330000
173400         OPEN INPUT CARD-FILE                                      17340000
173500         MOVE "OPEN" TO A510-CONTROL                               17350000
173600         PERFORM PRINT.                                            17360000
173700                                                                   17370000
173800 CLOSE-CARD-PRINTER.                                               17380000
173900     IF CARD-PRINTER-FLAG NOT EQUAL ZERO                           17390000
174000         MOVE ZERO TO CARD-PRINTER-FLAG                            17400000
174100         CLOSE CARD-FILE                                           17410000
174200         MOVE "CLSE" TO A510-CONTROL                               17420000
174300         PERFORM PRINT.                                            17430000
174400                                                                   17440000
174500 OUT-REPLY-CHECK.                                                  17450000
174600     IF REPLY-WORD NOT ZERO                                        17460000
174700         DISPLAY "FILE " OUT-NAME " REPLY " REPLY-WORD             17470000
174800         DISPLAY "ABANDON, OVERFLOW"                               17480000
174900         STOP 21.                                                  17490000
175000****                                                               17500000
